
;  AMD64 mpn_addlsh1_n -- rp[] = up[] + (vp[] << 1)
;  Copyright 2003, 2005, 2006, 2007, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"
%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx

%define reg_save_list rbp, rsi, rdi

    BITS 64
	SECTION .text

	xalign  16
	WIN64_GCC_PROC mpn_addlsh1_n, 4
	movsxd  rcx, ecx
	mov     r8, [rdx]
	mov     eax, ecx
	lea     rdi, [rdi+rcx*8]
	lea     rsi, [rsi+rcx*8]
	lea     rdx, [rdx+rcx*8]
	neg     rcx
	xor     ebp, ebp
	and     eax, 3
	je      L_b00
	cmp     eax, 2
	jc      L_b01
	je      L_b10
L_b11:	
    add     r8, r8
	mov     r9, [rdx+rcx*8+8]
	adc     r9, r9
	mov     r10, [rdx+rcx*8+16]
	adc     r10, r10
	sbb     eax, eax
	add     r8, [rsi+rcx*8]
	adc     r9, [rsi+rcx*8+8]
	mov     [rdi+rcx*8], r8
	mov     [rdi+rcx*8+8], r9
	adc     r10, [rsi+rcx*8+16]
	mov     [rdi+rcx*8+16], r10
	sbb     ebp, ebp
	add     rcx, 3
	jmp     L_ent
L_b10:	
    add     r8, r8
	mov     r9, [rdx+rcx*8+8]
	adc     r9, r9
	sbb     eax, eax
	add     r8, [rsi+rcx*8]
	adc     r9, [rsi+rcx*8+8]
	mov     [rdi+rcx*8], r8
	mov     [rdi+rcx*8+8], r9
	sbb     ebp, ebp
	add     rcx, 2
	jmp     L_ent
L_b01:	
    add     r8, r8
	sbb     eax, eax
	add     r8, [rsi+rcx*8]
	mov     [rdi+rcx*8], r8
	sbb     ebp, ebp
	inc     rcx
L_ent:	
    jns     L_end
    
	xalign  16
L_top:	
    add     eax, eax
	mov     r8, [rdx+rcx*8]
L_b00:	
    adc     r8, r8
	mov     r9, [rdx+rcx*8+8]
	adc     r9, r9
	mov     r10, [rdx+rcx*8+16]
	adc     r10, r10
	mov     r11, [rdx+rcx*8+24]
	adc     r11, r11
	sbb     eax, eax
	add     ebp, ebp
	adc     r8, [rsi+rcx*8]
	nop
	adc     r9, [rsi+rcx*8+8]
	mov     [rdi+rcx*8], r8
	mov     [rdi+rcx*8+8], r9
	adc     r10, [rsi+rcx*8+16]
	adc     r11, [rsi+rcx*8+24]
	mov     [rdi+rcx*8+16], r10
	mov     [rdi+rcx*8+24], r11
	sbb     ebp, ebp
	add     rcx, 4
	js      L_top
L_end:	
    add     eax, ebp
	neg     eax
	WIN64_GCC_END
	
	end

