
;  AMD64 mpn_addmul_2 -- Multiply an n-limb vector with a 2-limb vector and
;  add the result to a third limb vector.
;  Copyright 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n_param	rdx
%define 	vp	rcx
%define 	v0	r8
%define 	v1	r9
%define 	w0	rbx
%define 	w1	rcx
%define 	w2	rbp
%define 	w3	r10
%define 	n	r11

%define reg_save_list rbx, rbp, rsi, rdi

    BITS 64
	SECTION .text

	xalign  16
	WIN64_GCC_PROC mpn_addmul_2, 4
	movsxd  rdx, edx
	
	mov     r8, [rcx]
	mov     r9, [rcx+8]
	mov     r11, rdx
	neg     r11
	lea     rsi, [rsi+rdx*8-32]
	lea     rdi, [rdi+rdx*8-32]
	and     edx, 3
	jz      L_am2p0
	cmp     edx, 2
	jc      L_am2p1
	jz      L_am2p2
L_am2p3:
	mov     rax, [rsi+r11*8+32]
	mul     r8
	mov     rcx, rax
	mov     rax, [rsi+r11*8+32]
	mov     rbp, rdx
	xor     r10d, r10d
	add     r11, 2
	jmp     L_am3
L_am2p0:
	mov     rax, [rsi+r11*8+32]
	mul     r8
	mov     rbx, rax
	mov     rax, [rsi+r11*8+32]
	mov     rcx, rdx
	xor     ebp, ebp
	add     r11, 3
	jmp     L_am0
L_am2p1:
	mov     rax, [rsi+r11*8+32]
	mul     r8
	mov     r10, rax
	mov     rax, [rsi+r11*8+32]
	mov     rbx, rdx
	xor     ecx, ecx
	jmp     L_am1
L_am2p2:
	mov     rax, [rsi+r11*8+32]
	mul     r8
	mov     rbp, rax
	mov     rax, [rsi+r11*8+32]
	mov     r10, rdx
	xor     ebx, ebx
	xor     ecx, ecx
	add     r11, 1
	jmp     L_am2
	
	xalign  32
L_top:
	add     [rdi+r11*8], r10
	adc     rbx, rax
	mov     rax, [rsi+r11*8+8]
	adc     rcx, rdx
	mov     ebp, 0
	mul     r8
	add     rbx, rax
	mov     rax, [rsi+r11*8+8]
	adc     rcx, rdx
	adc     ebp, 0
L_am0:	
    mul     r9
	add     [rdi+r11*8+8], rbx
	adc     rcx, rax
	adc     rbp, rdx
	mov     rax, [rsi+r11*8+16]
	mov     r10d, 0
	mul     r8
	add     rcx, rax
	mov     rax, [rsi+r11*8+16]
	adc     rbp, rdx
	adc     r10d, 0
L_am3:	
    mul     r9
	add     [rdi+r11*8+16], rcx
	adc     rbp, rax
	mov     rax, [rsi+r11*8+24]
	adc     r10, rdx
	mul     r8
	mov     ebx, 0
	add     rbp, rax
	adc     r10, rdx
	mov     ecx, 0
	mov     rax, [rsi+r11*8+24]
	adc     ebx, 0
L_am2:	
    mul     r9
	add     [rdi+r11*8+24], rbp
	adc     r10, rax
	adc     rbx, rdx
	mov     rax, [rsi+r11*8+32]
	mul     r8
	add     r10, rax
	mov     rax, [rsi+r11*8+32]
	adc     rbx, rdx
	adc     ecx, 0
L_am1:	
    mul     r9
	add     r11, 4
	js      L_top
	add     [rdi+r11*8], r10
	adc     rbx, rax
	adc     rcx, rdx
	mov     [rdi+r11*8+8], rbx
	mov     rax, rcx
	WIN64_GCC_END
