
;  AMD64 mpn_addlsh_n and mpn_rsblsh_n.  R = V2^k +- U.
;  ("rsb" means reversed subtract, name mandated by mpn_sublsh1_n which
;  subtacts the shifted operand from the unshifted operand.)
;  Copyright 2006 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx
%define 	cnt	r8

%macro      func 1

	xalign  16
	mov     rax, rcx
	xor     ebx, ebx
	mov     ecx, r8d
	xor     r15d, r15d
	mov     r11d, eax
	and     r11d, 3
	je      %%2
	sub     r11d, 1
%%1:
	mov     r8, [rdx+0]
	mov     r12, r8
	shl     r8, cl
	or      r8, r15
	neg     cl
	mov     r15, r12
	shr     r15, cl
	neg     cl
	add     ebx, ebx
	%1      r8, [rsi+0]
	mov     [rdi+0], r8
	sbb     ebx, ebx
	lea     rsi, [rsi+8]
	lea     rdx, [rdx+8]
	lea     rdi, [rdi+8]
	sub     r11d, 1
	jnc     %%1
%%2:
	sub     rax, 4
	jc      %%4
%%3:
	mov     r8, [rdx+0]
	mov     r12, r8
	mov     r9, [rdx+8]
	mov     r13, r9
	mov     r10, [rdx+16]
	mov     r14, r10
	mov     r11, [rdx+24]
	shl     r8, cl
	shl     r9, cl
	shl     r10, cl
	or      r8, r15
	mov     r15, r11
	shl     r11, cl
	neg     cl
	shr     r12, cl
	shr     r13, cl
	shr     r14, cl
	shr     r15, cl
	or      r9, r12
	or      r10, r13
	or      r11, r14
	neg     cl
	add     ebx, ebx
	%1      r8, [rsi+0]
	%1      r9, [rsi+8]
	%1      r10, [rsi+16]
	%1      r11, [rsi+24]
	mov     [rdi+0], r8
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	mov     [rdi+24], r11
	sbb     ebx, ebx
	lea     rsi, [rsi+32]
	lea     rdx, [rdx+32]
	lea     rdi, [rdi+32]
	sub     rax, 4
	jnc     %%3
%%4:
	add     ebx, ebx
	adc     r15, 0
	mov     rax, r15

%endmacro

%define reg_save_list rbx, rsi, rdi, r12, r13, r14, r15

    BITS 64
	SECTION .text

	WIN64_GCC_PROC mpn_addlsh_n, 5
	movsxd  rcx, ecx
	func    adc
	WIN64_GCC_END

	WIN64_GCC_PROC mpn_rsblsh_n, 5
	movsxd  rcx, ecx
	func    sbb
	WIN64_GCC_END

    end
