
;  AMD64 mpn_add_n, mpn_sub_n
;  Copyright 2003, 2004, 2005, 2007, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx
%define 	cy	r8

%macro  func_nc 2

	xalign  16
	WIN64_GCC_PROC %2, 5
	movsxd  rcx, ecx
	
	mov     eax, ecx
	and     eax, 3
	shr     rcx, 2
	bt      r8, 0
	jz      %%5

    mov     r8, [rsi]
	mov     r9, [rsi+8]
	dec     rcx
	jmp     %%2
	
	xalign  16
%%1:
    %1      r8, [rdx]
	%1      r9, [rdx+8]
	%1      r10, [rdx+16]
	%1      r11, [rdx+24]
	mov     [rdi], r8
	lea     rsi, [rsi+32]
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	dec     rcx
	mov     [rdi+24], r11
	lea     rdx, [rdx+32]
	mov     r8, [rsi]
	mov     r9, [rsi+8]
	lea     rdi, [rdi+32]
%%2:
    mov     r10, [rsi+16]
	mov     r11, [rsi+24]
	jnz     %%1
%%3:
    lea     rsi, [rsi+32]
	%1      r8, [rdx]
	%1      r9, [rdx+8]
	%1      r10, [rdx+16]
	%1      r11, [rdx+24]
	lea     rdx, [rdx+32]
	mov     [rdi], r8
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	mov     [rdi+24], r11
	lea     rdi, [rdi+32]
	inc     eax
	dec     eax
	jnz     %%5
	adc     eax, eax
	jmp     %%8
%%4:	
    test    eax, eax
%%5:	
    dec     eax
	mov     r8, [rsi]
	jnz     %%6
	%1        r8, [rdx]
	mov     [rdi], r8
	adc     eax, eax
	jmp     %%8
%%6:	
    dec     eax
	mov     r9, [rsi+8]
	jnz     %%7
	%1      r8, [rdx]
	%1      r9, [rdx+8]
	mov     [rdi], r8
	mov     [rdi+8], r9
	adc     eax, eax
	jmp     %%8
%%7:	
    mov     r10, [rsi+16]
	%1      r8, [rdx]
	%1      r9, [rdx+8]
	%1      r10, [rdx+16]
	mov     [rdi], r8
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	setc    al
%%8:
	WIN64_GCC_END

%endmacro

%macro  func 2

	xalign  16
	WIN64_GCC_PROC %2, 4
	movsxd  rcx, ecx
	
	mov     eax, ecx
	shr     rcx, 2
	jz      %%4
	and     eax, 3
    mov     r8, [rsi]
	mov     r9, [rsi+8]
	dec     rcx
	jmp     %%2
	
	xalign  16
%%1:
    %1      r8, [rdx]
	%1      r9, [rdx+8]
	%1      r10, [rdx+16]
	%1      r11, [rdx+24]
	mov     [rdi], r8
	lea     rsi, [rsi+32]
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	dec     rcx
	mov     [rdi+24], r11
	lea     rdx, [rdx+32]
	mov     r8, [rsi]
	mov     r9, [rsi+8]
	lea     rdi, [rdi+32]
%%2:
    mov     r10, [rsi+16]
	mov     r11, [rsi+24]
	jnz     %%1
%%3:
    lea     rsi, [rsi+32]
	%1      r8, [rdx]
	%1      r9, [rdx+8]
	%1      r10, [rdx+16]
	%1      r11, [rdx+24]
	lea     rdx, [rdx+32]
	mov     [rdi], r8
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	mov     [rdi+24], r11
	lea     rdi, [rdi+32]
	inc     eax
	dec     eax
	jnz     %%5
	adc     eax, eax
	jmp     %%8
%%4:	
    test    eax, eax
%%5:	
    dec     eax
	mov     r8, [rsi]
	jnz     %%6
	%1        r8, [rdx]
	mov     [rdi], r8
	adc     eax, eax
	jmp     %%8
%%6:	
    dec     eax
	mov     r9, [rsi+8]
	jnz     %%7
	%1      r8, [rdx]
	%1      r9, [rdx+8]
	mov     [rdi], r8
	mov     [rdi+8], r9
	adc     eax, eax
	jmp     %%8
%%7:	
    mov     r10, [rsi+16]
	%1      r8, [rdx]
	%1      r9, [rdx+8]
	%1      r10, [rdx+16]
	mov     [rdi], r8
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	setc    al
%%8:
	WIN64_GCC_END

%endmacro

%define reg_save_list rsi, rdi

    BITS    64
	SECTION .text

    func_nc adc, mpn_add_nc
    func    adc, mpn_add_n
    func_nc sbb, mpn_sub_nc
    func    sbb, mpn_sub_n
   
    end
