
;  AMD64 mpn_addmul_1 and mpn_submul_1.
;  Copyright 2003, 2004, 2005, 2007, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n_param	rdx
%define 	vl	rcx
%define 	n	r11

%macro  func 1

	xalign  16
	mov     rax, [rsi]
	mov     rbx, rdx
	mul     rcx
	mov     r11, rbx
	and     ebx, 3
	jz      %%2
	cmp     ebx, 2
	jz      %%4
	jg      %%3
%%0:	
    dec     r11
	jne     %%1
	%1      [rdi], rax
	jmp     %%10
%%1:	
    lea     rsi, [rsi+r11*8+8]
	lea     rdi, [rdi+r11*8-8]
	neg     r11
	xor     r10, r10
	xor     ebx, ebx
	mov     r9, rax
	mov     rax, [rsi+r11*8]
	mov     r8, rdx
	jmp     %%6
%%2:	
    lea     rsi, [rsi+r11*8]
	lea     rdi, [rdi+r11*8-16]
	neg     r11
	xor     r10, r10
	mov     r8, rax
	mov     rbx, rdx
	jmp     %%7
%%3:	
    lea     rsi, [rsi+r11*8-8]
	lea     rdi, [rdi+r11*8-24]
	neg     r11
	mov     rbx, rax
	mov     r10, rdx
	jmp     %%8
%%4:	
    lea     rsi, [rsi+r11*8-16]
	lea     rdi, [rdi+r11*8-32]
	neg     r11
	xor     r8, r8
	xor     ebx, ebx
	mov     r10, rax
	mov     rax, [rsi+r11*8+24]
	mov     r9, rdx
	jmp     %%9
	
	xalign  16
%%5:	
	%1      [rdi+r11*8], r10
	adc     r9, rax
	mov     rax, [rsi+r11*8]
	adc     r8, rdx
	mov     r10d, 0
%%6:	
    mul     rcx
	%1      [rdi+r11*8+8], r9
	adc     r8, rax
	adc     rbx, rdx
%%7:	
    mov     rax, [rsi+r11*8+8]
	mul     rcx
	%1      [rdi+r11*8+16], r8
	adc     rbx, rax
	adc     r10, rdx
%%8:	
    mov     rax, [rsi+r11*8+16]
	mul     rcx
	%1      [rdi+r11*8+24], rbx
	mov	    r8d, 0
	mov	    rbx, r8
	adc     r10, rax
	mov     rax, [rsi+r11*8+24]
	mov	    r9, r8
	adc     r9, rdx
%%9:	
    mul     rcx
	add     r11, 4
	js      %%5
	%1      [rdi+r11*8], r10
	adc     r9, rax
	adc     rdx, r8
	%1      [rdi+r11*8+8], r9
%%10:	
    adc     rdx, 0
	mov     rax, rdx
	
%endmacro

%define reg_save_list rbx, rsi, rdi

    BITS    64
	SECTION .text

	WIN64_GCC_PROC mpn_addmul_1, 4 
	movsxd  rdx, edx
	func    add
	WIN64_GCC_END

	WIN64_GCC_PROC mpn_submul_1, 4 
	movsxd  rdx, edx
	func    sub
	WIN64_GCC_END

    end
