
;  X86-64 mpn_add_n, mpn_sub_n, optimized for Intel Atom.
;  Copyright 2003, 2004, 2005, 2007, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "..\yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx
%define 	cy	r8

%macro  func 3

	xalign  16
	WIN64_GCC_PROC %2, frame_fun, 5
	movsxd  rcx, ecx
	jmp     %%1

	xalign  16
	WIN64_GCC_PROC %3, frame_fun, 4
	movsxd  rcx, ecx
	xor     r8, r8

%%1:
	mov     eax, ecx
	shr     rcx, 2
	and     eax, 3
	jz      %%8
	cmp     eax, 2
	jz      %%4
	jg      %%6
%%2:	
    mov     r10, [rsi]
	test    ecx, ecx
	bt      r8d, 0
	jnz     %%3
	%1      r10, [rdx]
	mov     [rdi], r10
	mov     eax, ecx
	adc     eax, eax
	ret
%%3:	
    %1      r10, [rdx]
	mov     r11, [rsi+8]
	lea     rsi, [rsi+16]
	lea     rdx, [rdx-16]
	lea     rdi, [rdi-16]
	jmp     %%12
%%4:
	mov     r9, [rsi]
	mov     r10, [rsi+8]
	lea     rdx, [rdx-8]
	test    ecx, ecx
	bt      r8d, 0
	jnz     %%5
	lea     rdi, [rdi-40]
	jmp     %%15
%%5:
	%1      r9, [rdx+8]
	mov     r11, [rsi+16]
	lea     rsi, [rsi-8]
	lea     rdi, [rdi-8]
	jmp     %%11
%%6:
	mov     rax, [rsi]
	mov     r9, [rsi+8]
	mov     r10, [rsi+16]
	test    ecx, ecx
	bt      r8, 0
	jnz     %%7
	lea     rdi, [rdi-32]
	jmp     %%14
%%7:
	%1      rax, [rdx]
	jmp     %%10
%%8:
	mov     r11, [rsi]
	neg     r8d
	lea     rdx, [rdx-24]
	lea     rdi, [rdi-24]
	lea     rsi, [rsi+8]
	jmp     %%13
	xalign  8
%%9:
	mov     [rdi+24], r11
	%1      rax, [rdx]
	lea     rdi, [rdi+32]
%%10:
	mov     [rdi], rax
	%1      r9, [rdx+8]
	mov     r11, [rsi+24]
%%11:
	mov     [rdi+8], r9
	%1      r10, [rdx+16]
	lea     rsi, [rsi+32]
%%12:
	mov     [rdi+16], r10
%%13:
	%1      r11, [rdx+24]
	mov     rax, [rsi]
	mov     r9, [rsi+8]
	lea     rdx, [rdx+32]
	dec     rcx
	mov     r10, [rsi+16]
	jnz     %%9
	mov     [rdi+24], r11
%%14:
	%1      rax, [rdx]
	mov     [rdi+32], rax
%%15:
	%1      r9, [rdx+8]
	mov     [rdi+40], r9
%%16:
	%1      r10, [rdx+16]
	mov     [rdi+48], r10
	mov     eax, ecx
	adc     eax, eax
	WIN64_GCC_END
	
%endmacro

%define reg_save_list rsi, rdi
%stack_slots          0

    BITS    64
	TEXT

    func    adc, mpn_add_nc, mpn_add_n
    func    sbb, mpn_sub_nc, mpn_sub_n
   
    end
