
;  AMD64 mpn_copyd -- copy limb vector, decrementing.
;  Copyright 2003, 2005, 2007 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n	rdx

%define reg_save_list rsi, rdi

    BITS    64
	SECTION .text

	xalign  16
	WIN64_GCC_PROC mpn_copyd, 3
	movsxd  rdx, edx
	lea     rsi, [rsi+rdx*8-8]
	lea     rdi, [rdi+rdx*8]
	sub     rdx, 4
	jc      L_end
	
	xalign  16
L_oop:	
    mov     r8, [rsi]
	mov     r9, [rsi-8]
	lea     rdi, [rdi-32]
	mov     r10, [rsi-16]
	mov     r11, [rsi-24]
	lea     rsi, [rsi-32]
	mov     [rdi+24], r8
	mov     [rdi+16], r9
	sub     rdx, 4
	mov     [rdi+8], r10
	mov    [rdi], r11
	jnc     L_oop
L_end:
    shr 	edx, 1	
	jnc	    L_1
	mov     r8, [rsi]
	mov     [rdi-8], r8
	lea     rdi, [rdi-8]
	lea     rsi, [rsi-8]
L_1:
	shr 	edx, 1
	jnc	    L_2
	mov     r8, [rsi]
	mov     r9, [rsi-8]
	mov     [rdi-8], r8
	mov     [rdi-16], r9
L_2:
	WIN64_GCC_END

    end    
