
;  Intel P6-15 mpn_add_n/mpn_sub_n -- mpn add or subtract.
;  Copyright 2006, 2007 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "..\yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx
%define 	cy	r8

%macro  func 3

	xalign  16
	WIN64_GCC_PROC %2, frame_fun, 5
	movsxd  rcx, ecx
	jmp     %%1

	xalign  16
	WIN64_GCC_PROC %3, frame_fun, 4
	movsxd  rcx, ecx
	xor     r8, r8

%%1:
	mov     r10, [rsi]
	mov     r11, [rdx]
	lea     rsi, [rsi+rcx*8-8]
	lea     rdx, [rdx+rcx*8-8]
	lea     rdi, [rdi+rcx*8-16]
	mov     eax, ecx
	neg     rcx
	and     eax, 3
	je      %%3
	add     rcx, rax
	cmp     eax, 2
	jl      %%4
	je      %%5
%%2:	
    shr     r8
	jmp     %%9
%%3:
	shr     r8
	mov     r8, r10
	mov     r9, r11
	lea     rcx, [rcx+4]
	jmp     %%8
%%4:
	shr     r8
	jmp     %%11
%%5:
	shr     r8
	mov     r8, r10
	mov     r9, r11
	jmp     %%10
%%6:
	%1      r10, r11
	mov     [rdi+8], r10
	mov     eax, ecx
	adc     eax, eax
	jmp     %%12
	
	xalign  16
%%7:
	mov     r8, [rsi+rcx*8-24]
	mov     r9, [rdx+rcx*8-24]
	%1      r10, r11
	mov     [rdi+rcx*8-24], r10
%%8:
	mov     r10, [rsi+rcx*8-16]
	mov     r11, [rdx+rcx*8-16]
	%1      r8, r9
	mov     [rdi+rcx*8-16], r8
%%9:
	mov     r8, [rsi+rcx*8-8]
	mov     r9, [rdx+rcx*8-8]
	%1      r10, r11
	mov     [rdi+rcx*8-8], r10
%%10:
	mov     r10, [rsi+rcx*8]
	mov     r11, [rdx+rcx*8]
	%1      r8, r9
	mov     [rdi+rcx*8], r8
%%11:
	jrcxz   %%6
	lea     rcx, [rcx+4]
	jmp     %%7
%%12:
	WIN64_GCC_END
	
%endmacro

%define reg_save_list rsi, rdi
%stack_slots          0

    BITS    64
	TEXT

    func    adc, mpn_add_nc, mpn_add_n
    func    sbb, mpn_sub_nc, mpn_sub_n
   
    end
