
;  x86-64 mpn_addlsh1_n and mpn_sublsh1_n, optimized for "Core" 2.
;  Copyright 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "..\yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx

%macro  func 3

	xalign  8
	WIN64_GCC_PROC %3, frame_fun, 4
	movsxd  rcx, ecx
	
	mov     eax, ecx
	lea     rsi, [rsi+rcx*8+24]
	lea     rdx, [rdx+rcx*8+24]
	lea     rdi, [rdi+rcx*8+24]
	neg     rcx
	xor     r11d, r11d
	mov     r8, [rdx+rcx*8-24]
	shrd    r11, r8, 63
	and     eax, 3
	je      %%5
	cmp     eax, 2
	jc      %%2
	je      %%3
%%1:	
    mov     r9, [rdx+rcx*8-16]
	shrd    r8, r9, 63
	mov     r10, [rdx+rcx*8-8]
	shrd    r9, r10, 63
	mov     r12, [rsi+rcx*8-24]
	%1      r12, r11
	mov     [rdi+rcx*8-24], r12
	mov     r12, [rsi+rcx*8-16]
	%2      r12, r8
	mov     [rdi+rcx*8-16], r12
	mov     r12, [rsi+rcx*8-8]
	%2      r12, r9
	mov     [rdi+rcx*8-8], r12
	mov     r11, r10
	sbb     eax, eax
	add     rcx, 3
	js      %%4
	jmp     %%6
%%2:
	mov     r12, [rsi+rcx*8-24]
	%1      r12, r11
	mov     [rdi+rcx*8-24], r12
	mov     r11, r8
	sbb     eax, eax
	inc     rcx
	js      %%4
	jmp     %%6
%%3:
	mov     r9, [rdx+rcx*8-16]
	shrd    r8, r9, 63
	mov     r12, [rsi+rcx*8-24]
	%1      r12, r11
	mov     [rdi+rcx*8-24], r12
	mov     r12, [rsi+rcx*8-16]
	%2      r12, r8
	mov     [rdi+rcx*8-16], r12
	mov     r11, r9
	sbb     eax, eax
	add     rcx, 2
	js      %%4
	jmp     %%6
	
	xalign  16
%%4:	
    mov     r8, [rdx+rcx*8-24]
	shrd    r11, r8, 63
%%5:
	mov     r9, [rdx+rcx*8-16]
	shrd    r8, r9, 63
	mov     r10, [rdx+rcx*8-8]
	shrd    r9, r10, 63
	mov     rbx, [rdx+rcx*8]
	shrd    r10, rbx, 63
	add     eax, eax
	mov     r12, [rsi+rcx*8-24]
	%2      r12, r11
	mov     [rdi+rcx*8-24], r12
	mov     r12, [rsi+rcx*8-16]
	%2      r12, r8
	mov     [rdi+rcx*8-16], r12
	mov     r12, [rsi+rcx*8-8]
	%2      r12, r9
	mov     [rdi+rcx*8-8], r12
	mov     r12, [rsi+rcx*8]
	%2      r12, r10
	mov     [rdi+rcx*8], r12
	mov     r11, rbx
	sbb     eax, eax
	add     rcx, 4
	js      %%4
%%6:
	add     r11, r11
	sbb     eax, 0
	neg     eax
	WIN64_GCC_END

    BITS    64
    TEXT
    	
%define reg_save_list rbx, rsi, rdi, r12
%stack_slots          0

    func add, adc, mpn_addlsh1_n
    func sub, sbb, mpn_sublsh1_n
    
    end
