
;  x86-64 mpn_addmul_1 and mpn_submul_1, optimized for "Core 2".
;  Copyright 2003, 2004, 2005, 2007, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "..\yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n	rdx
%define 	v0	rcx

%macro  func 2

	xalign  16
	WIN64_GCC_PROC %2, frame_fun, 4
	movsxd  rdx, edx
	
	lea     r15, [rdx]
	neg     r15
	mov     rax, [rsi]
	bt      r15, 0
	jc      %%1
	lea     rdi, [rdi+rdx*8]
	lea     rsi, [rsi+rdx*8]
	mul     rcx
	lea     r11, [rax]
	mov     rax, [rsi+r15*8+8]
	mov     r13, [rdi+r15*8]
	lea     r12, [rdx]
	add     r15, 2
	jns     %%7
	mul     rcx
	lea     r8, [rax]
	mov     rax, [rsi+r15*8]
	mov     r10, [rdi+r15*8-8]
	lea     r9, [rdx]
	jmp     %%4
%%1:	
    lea     rdi, [rdi+rdx*8]
	lea     rsi, [rsi+rdx*8]
	mul     rcx
	add     r15, 1
	jns     %%8
%%2:
  	lea     r8, [rax]
	mov     rax, [rsi+r15*8]
	mov     r10, [rdi+r15*8-8]
	lea     r9, [rdx]
	mul     rcx
	lea     r11, [rax]
	mov     rax, [rsi+r15*8+8]
	mov     r13, [rdi+r15*8]
	lea     r12, [rdx]
	add     r15, 2
	jns     %%5
	
	xalign  16
%%3:
	mul     rcx
	%1      r10, r8
	lea     r8, [rax]
	mov     rax, [rsi+r15*8+0]
	adc     r11, r9
	mov     [rdi+r15*8-24], r10
	mov     r10, [rdi+r15*8-8]
	lea     r9, [rdx]
	adc     r12, 0
%%4:	
    mul     rcx
	%1      r13, r11
	lea     r11, [rax]
	mov     rax, [rsi+r15*8+8]
	adc     r8, r12
	mov     [rdi+r15*8-16], r13
	mov     r13, [rdi+r15*8+0]
	lea     r12, [rdx]
	adc     r9, 0
	add     r15, 2
	js      %%3
%%5:	
    mul     rcx
	%1      r10, r8
	adc     r11, r9
	mov     [rdi+r15*8-24], r10
	mov     r10, [rdi+r15*8-8]
	adc     r12, 0
%%6:
	%1      r13, r11
	adc     rax, r12
	mov     [rdi+r15*8-16], r13
	adc     rdx, 0
	jmp     %%9
%%7:
	mul     rcx
	mov     r10, [rdi+r15*8-8]
	jmp     %%6
%%8:
	mov     r10, [rdi+r15*8-8]
%%9:
	%1      r10, rax
	mov     [rdi+r15*8-8], r10
	mov     eax, 0
	adc     rax, rdx
	WIN64_GCC_END

%endmacro
	
%define reg_save_list rsi, rdi, r12, r13, r15
%stack_slots          0

    BITS 64
	TEXT

    func add, mpn_addmul_1
    func sub, mpn_submul_1
    
    end
    
