
;  x86-64 mpn_lshift optimized for "Core 2".
;  Copyright 2007 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;
;  This file is part of the GNU MP Library.
;
;  The GNU MP Library is free software; you can redistribute it and/or
;  modify it under the terms of the GNU Lesser General Public License as
;  published by the Free Software Foundation; either version 3 of the
;  License, or (at your option) any later version.
;
;  The GNU MP Library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;  Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "..\yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n	rdx
%define 	cnt	cl


%define reg_save_list rsi, rdi
%stack_slots          0

    BITS    64
	TEXT

	xalign  16
	WIN64_GCC_PROC mpn_lshift, frame_fun, 4
	movsxd  rdx, edx
	
	lea     rdi, [rdi+rdx*8-8]
	lea     rsi, [rsi+rdx*8-8]
	mov     eax, edx
	and     eax, 3
	jne     L_nb00
L_b00:
	mov     r10, [rsi]
	mov     r11, [rsi-8]
	xor     eax, eax
	shld    r10, cl
	mov     r8, [rsi-16]
	lea     rdi, [rdi+24]
	sub     rdx, 4
	jmp     L_00
L_nb00:
	cmp     eax, 2
	jae     L_nb01
L_b01:
	mov     r9, [rsi]
	xor     eax, eax
	shld    r9, cl
	sub     rdx, 2
	jb      L_le1
	mov     r10, [rsi-8]
	mov     r11, [rsi-16]
	lea     rsi, [rsi-8]
	lea     rdi, [rdi+16]
	jmp     L_01
L_le1:
	shl     r9, cl
	mov     [rdi], r9
	ret
L_nb01:
	jne     L_b11
L_b10:
	mov     r8, [rsi]
	mov     r9, [rsi-8]
	xor     eax, eax
	shld    r8, cl
	sub     rdx, 3
	jb      L_le2
	mov     r10, [rsi-16]
	lea     rsi, [rsi-16]
	lea     rdi, [rdi+8]
	jmp     L_10
L_le2:
	shld    r9, cl
	mov     [rdi], r8
	shl     r9, cl
	mov     [rdi-8], r9
	jmp     L_xit
	
	xalign  16
L_b11:
	mov     r11, [rsi]
	mov     r8, [rsi-8]
	xor     eax, eax
	shld    r11, cl
	mov     r9, [rsi-16]
	lea     rsi, [rsi-24]
	sub     rdx, 4
	jb      L_end

	xalign  16
L_top:
	shld    r8, cl
	mov     r10, [rsi]
	mov     [rdi], r11
L_10:
	shld    r9, cl
	mov     r11, [rsi-8]
	mov     [rdi-8], r8
L_01:
	shld    r10, cl
	mov     r8, [rsi-16]
	mov     [rdi-16], r9
L_00:
	shld    r11, cl
	mov     r9, [rsi-24]
	lea     rsi, [rsi-32]
	mov     [rdi-24], r10
	lea     rdi, [rdi-32]
	sub     rdx, 4
	jnc     L_top
L_end:	
    shld    r8, cl
	mov     [rdi], r11
	shld    r9, cl
	mov     [rdi-8], r8
	shl     r9, cl
	mov     [rdi-16], r9
L_xit:
	WIN64_GCC_END
	
	end
