
;  AMD64 mpn_divexact_1 -- mpn by limb exact division.
;  Copyright 2001, 2002, 2004, 2005, 2006 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
; The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define reg_save_list rbx, rsi, rdi

    BITS    64
	SECTION .text
    extern  __gmp_binvert_limb_table

	xalign  16
	WIN64_GCC_PROC mpn_divexact_1, 4
	movsxd  rdx, edx
	
	mov     rax, rcx
	mov     ecx, 0
	mov     r8, rdx
	bt      eax, 0
	jnc     L_evn
L_odd:	
    mov     rbx, rax
	shr     eax, 1
	and     eax, 127
	lea     rdx, [rel __gmp_binvert_limb_table]
	movzx   eax, byte [rax+rdx]
	mov     r11, rbx
	
	lea     edx, [rax+rax]
	imul    eax, eax
	imul    eax, ebx
	sub     edx, eax
	
	lea     eax, [rdx+rdx]
	imul    edx, edx
	imul    edx, ebx
	sub     eax, edx
	
	lea     rdx, [rax+rax]
	imul    rax, rax
	imul    rax, rbx
	sub     rdx, rax
	
	lea     rsi, [rsi+r8*8]
	lea     rdi, [rdi+r8*8-8]
	neg     r8
	mov     r10, rdx
	mov     rax, [rsi+r8*8]
	inc     r8
	jz      L_one
	mov     rdx, [rsi+r8*8]
	shrd    rax, rdx, cl
	xor     ebx, ebx
	jmp     L_entry
L_evn:	
    bsf     rcx, rax
	shr     rax, cl
	jmp     L_odd
	
	xalign  8
L_top:
	mul     r11
	mov     rax, [rsi+r8*8-8]
	mov     r9, [rsi+r8*8]
	shrd    rax, r9, cl
	nop
	sub     rax, rbx
	setc    bl
	sub     rax, rdx
	adc     rbx, 0
L_entry:
	imul    rax, r10
	mov     [rdi+r8*8], rax
	inc     r8
	jnz     L_top
	mul     r11
	mov     rax, [rsi-8]
	shr     rax, cl
	sub     rax, rbx
	sub     rax, rdx
	imul    rax, r10
	mov     [rdi], rax
	jmp     L_end
L_one:
	shr     rax, cl
	imul    rax, r10
	mov     [rdi], rax
L_end:
	WIN64_GCC_END

    end
 