
;  x86-64 mpn_divrem_1 -- mpn by limb division.
;  Copyright 2004, 2005, 2007, 2008, 2009 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

;	mp_limb_t mpn_divrem_1 (mp_ptr qp, mp_size_t fn, mp_srcptr np, mp_size_t nn, mp_limb_t d)
;	mp_limb_t mpn_preinv_divrem_1 (mp_ptr qp, mp_size_t fn, mp_srcptr np, mp_size_t nn, mp_limb_t d, mp_limb_t dinv, int cnt)

%include "yasm_mac.inc"

%define SPECIAL_CODE_FOR_NORMALIZED_DIVISOR 1
%define 	qp	rdi
%define 	fn_param	rsi
%define 	up_param	rdx
%define 	un_param	rcx
%define 	d	r8
%define 	dinv	r9
;	shift passed on stack		C only for mpn_preinv_divrem_1
%define 	cnt	rcx
%define 	up	rsi
%define 	fn	r12
%define 	un	rbx

%define reg_save_list rbx, rbp, rsi, rdi, r12, r13

    BITS    64
	SECTION .text

	xalign  16
	WIN64_GCC_PROC mpn_preinv_divrem_1, 7
	movsxd  rsi, esi
	movsxd  rcx, ecx
	
	xor     eax, eax
	mov     r12, rsi
	mov     rbx, rcx
	add     rcx, rsi
	mov     rsi, rdx
	lea     rdi, [rdi+rcx*8-8]
	test    r8, r8
	js      .nent
	mov     cl, [rsp+stack_use+0x38]
	shl     r8, cl
	jmp     .uent
		
%ifdef  SPECIAL_CODE_FOR_NORMALIZED_DIVISOR

	test    r8, r8
	jns     .unnormalized
.normalized:
	test    rbx, rbx
	mov     rbp, [rsi+rbx*8-8]
	dec     rbx
	mov     rax, rbp
	sub     rbp, r8
	cmovb   rbp, rax
	sbb     eax, eax
	inc     eax
	mov     [rdi], rax
	lea     rdi, [rdi-8]
.8:
	mov     rdx, r8
	mov     rax, -1
	not     rdx
	div     r8
	mov     r9, rax
	mov     rax, rbp
	jmp     .nent
	xalign  16
.nloop:
	mov     r10, [rsi+rbx*8]
	lea     rbp, [rax+1]
	mul     r9
	add     rax, r10
	adc     rdx, rbp
	mov     rbp, rax
	mov     r13, rdx
	imul    rdx, r8
	sub     r10, rdx
	mov     rax, r8
	add     rax, r10
	cmp     r10, rbp
	cmovb   rax, r10
	adc     r13, -1
	cmp     rax, r8
	jae     .nfx
.nok:	
    mov     [rdi], r13
	sub     rdi, 8
.nent:	
    dec     rbx
	jns     .nloop
	xor     ecx, ecx
	jmp     .87
.nfx:	
    sub     rax, r8
	inc     r13
	jmp     .nok

%endif

.unnormalized:
	test    rbx, rbx
	je      .44
	mov     rax, [rsi+rbx*8-8]
	cmp     rax, r8
	jae     .44
	mov     [rdi], rbp
	mov     rbp, rax
	lea     rdi, [rdi-8]
	je      .ret
	dec     rbx
.44:
	bsr     rcx, r8
	not     ecx
	sal     r8, cl
	sal     rbp, cl
	mov     rdx, r8
	mov     rax, -1
	not     rdx
	div     r8
	test    rbx, rbx
	mov     r9, rax
	mov     rax, rbp
	je      .87
.uent:
	mov     rbp, [rsi+rbx*8-8]
	shr     rax, cl
	shld    rax, rbp, cl
	sub     rbx, 2
	js      .ulast
	xalign  16
.uloop:
	nop
	mov     r10, [rsi+rbx*8]
	lea     r11, [rax+1]
	shld    rbp, r10, cl
	mul     r9
	add     rax, rbp
	adc     rdx, r11
	mov     r11, rax
	mov     r13, rdx
	imul    rdx, r8
	sub     rbp, rdx
	mov     rax, r8
	add     rax, rbp
	cmp     rbp, r11
	cmovb   rax, rbp
	adc     r13, -1
	cmp     rax, r8
	jae     .ufx
.uok:	
    mov     [rdi], r13
	sub     rdi, 8
	dec     rbx
	mov     rbp, r10
	jns     .uloop
.ulast:
	lea     r11, [rax+1]
	sal     rbp, cl
	mul     r9
	add     rax, rbp
	adc     rdx, r11
	mov     r11, rax
	mov     r13, rdx
	imul    rdx, r8
	sub     rbp, rdx
	mov     rax, r8
	add     rax, rbp
	cmp     rbp, r11
	cmovb   rax, rbp
	adc     r13, -1
	cmp     rax, r8
	jae     .93
.69:	
    mov     [rdi], r13
	sub     rdi, 8
	jmp     .87
.ufx:	
    sub     rax, r8
	inc     r13
	jmp     .uok
.93:	
    sub     rax, r8
	inc     r13
	jmp     .69
.87:	
    mov     rbp, r8
	neg     rbp
	jmp     .87b
	xalign  16
.floop:
	lea     r11, [rax+1]
	mul     r9
	add     rdx, r11
	mov     r11, rax
	mov     r13, rdx
	imul    rdx, rbp
	mov     rax, r8
	add     rax, rdx
	cmp     rdx, r11
	cmovb   rax, rdx
	adc     r13, -1
	mov     [rdi], r13
	sub     rdi, 8
.87b:	
    dec     r12
	jns     .floop
	shr     rax, cl
.ret:	
	WIN64_GCC_END

	xalign  16
	WIN64_GCC_PROC mpn_divrem_1, 5
	movsxd  rsi, esi
	movsxd  rcx, ecx
	
	xor     eax, eax
	mov     r12, rsi
	mov     rbx, rcx
	add     rcx, rsi
	mov     rsi, rdx
	je      .ret
	lea     rdi, [rdi+rcx*8-8]
	xor     ebp, ebp
	
%ifdef  SPECIAL_CODE_FOR_NORMALIZED_DIVISOR

	test    r8, r8
	jns     .unnormalized
.normalized:
	test    rbx, rbx
	mov     rbp, [rsi+rbx*8-8]
	dec     rbx
	mov     rax, rbp
	sub     rbp, r8
	cmovb   rbp, rax
	sbb     eax, eax
	inc     eax
	mov     [rdi], rax
	lea     rdi, [rdi-8]
.8:
	mov     rdx, r8
	mov     rax, -1
	not     rdx
	div     r8
	mov     r9, rax
	mov     rax, rbp
	jmp     .nent
	xalign  16
.nloop:
	mov     r10, [rsi+rbx*8]
	lea     rbp, [rax+1]
	mul     r9
	add     rax, r10
	adc     rdx, rbp
	mov     rbp, rax
	mov     r13, rdx
	imul    rdx, r8
	sub     r10, rdx
	mov     rax, r8
	add     rax, r10
	cmp     r10, rbp
	cmovb   rax, r10
	adc     r13, -1
	cmp     rax, r8
	jae     .nfx
.nok:	
    mov     [rdi], r13
	sub     rdi, 8
.nent:	
    dec     rbx
	jns     .nloop
	xor     ecx, ecx
	jmp     .87
.nfx:	
    sub     rax, r8
	inc     r13
	jmp     .nok

%endif

.unnormalized:
	test    rbx, rbx
	je      .44
	mov     rax, [rsi+rbx*8-8]
	cmp     rax, r8
	jae     .44
	mov     [rdi], rbp
	mov     rbp, rax
	lea     rdi, [rdi-8]
	je      .ret
	dec     rbx
.44:
	bsr     rcx, r8
	not     ecx
	sal     r8, cl
	sal     rbp, cl
	mov     rdx, r8
	mov     rax, -1
	not     rdx
	div     r8
	test    rbx, rbx
	mov     r9, rax
	mov     rax, rbp
	je      .87
.uent:
	mov     rbp, [rsi+rbx*8-8]
	shr     rax, cl
	shld    rax, rbp, cl
	sub     rbx, 2
	js      .ulast
	
	xalign  16
.uloop:
	nop
	mov     r10, [rsi+rbx*8]
	lea     r11, [rax+1]
	shld    rbp, r10, cl
	mul     r9
	add     rax, rbp
	adc     rdx, r11
	mov     r11, rax
	mov     r13, rdx
	imul    rdx, r8
	sub     rbp, rdx
	mov     rax, r8
	add     rax, rbp
	cmp     rbp, r11
	cmovb   rax, rbp
	adc     r13, -1
	cmp     rax, r8
	jae     .ufx
.uok:	
    mov     [rdi], r13
	sub     rdi, 8
	dec     rbx
	mov     rbp, r10
	jns     .uloop
.ulast:
	lea     r11, [rax+1]
	sal     rbp, cl
	mul     r9
	add     rax, rbp
	adc     rdx, r11
	mov     r11, rax
	mov     r13, rdx
	imul    rdx, r8
	sub     rbp, rdx
	mov     rax, r8
	add     rax, rbp
	cmp     rbp, r11
	cmovb   rax, rbp
	adc     r13, -1
	cmp     rax, r8
	jae     .93
.69:	
    mov     [rdi], r13
	sub     rdi, 8
	jmp     .87
.ufx:	
    sub     rax, r8
	inc     r13
	jmp     .uok
.93:	
    sub     rax, r8
	inc     r13
	jmp     .69
.87:	
    mov     rbp, r8
	neg     rbp
	jmp     .87b
	
	xalign  16
.floop:
	lea     r11, [rax+1]
	mul     r9
	add     rdx, r11
	mov     r11, rax
	mov     r13, rdx
	imul    rdx, rbp
	mov     rax, r8
	add     rax, rdx
	cmp     rdx, r11
	cmovb   rax, rdx
	adc     r13, -1
	mov     [rdi], r13
	sub     rdi, 8
.87b:	
    dec     r12
	jns     .floop
	shr     rax, cl
.ret:	
	WIN64_GCC_END

    end
