
;  AMD64 logops.
;  Copyright 2004, 2005, 2006 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define rp  rcx
%define up  rdx
%define vp   r8
%define n    r9

%macro  func 3

    xalign  32
    LEAF_PROC %2
    movsxd  r9, r9d

%ifidn %3, v1

    mov     r10, [r8]
    mov     eax, r9d
    lea     r8, [r8+r9*8]
    lea     rdx, [rdx+r9*8]
    lea     rcx, [rcx+r9*8]
    neg     r9
    and     eax, 3
    je      %%5
    cmp     eax, 2
    jc      %%3
    je      %%2
%%1:
    %1      r10, [rdx+r9*8]
    mov     [rcx+r9*8], r10
    dec     r9
   jmp     %%6
%%2:
    add     r9, -2
    jmp     %%7
%%3:
    %1      r10, [rdx+r9*8]
    mov     [rcx+r9*8], r10
    inc     r9
    jz      %%8
%%4:
    mov     r10, [r8+r9*8]
%%5:
    mov     r11, [r8+r9*8+8]
    %1      r10, [rdx+r9*8]
    %1      r11, [rdx+r9*8+8]
    nop
    mov     [rcx+r9*8], r10
    mov     [rcx+r9*8+8], r11
%%6:
    mov     r10, [r8+r9*8+16]
%%7:
    mov     r11, [r8+r9*8+24]
    %1      r10, [rdx+r9*8+16]
    %1      r11, [rdx+r9*8+24]
    mov     [rcx+r9*8+16], r10
    mov     [rcx+r9*8+24], r11
    add     r9, 4
    jnc     %%4
%%8:
    ret

%endif

%ifidn %3, v2

    mov     r10, [r8]
    not     r10
    mov     eax, r9d
    lea     r8, [r8+r9*8]
    lea     rdx, [rdx+r9*8]
    lea     rcx, [rcx+r9*8]
    neg     r9
    and     eax, 3
    je      %%15
    cmp     eax, 2
    jc      %%13
    je      %%12
%%11:
    %1      r10, [rdx+r9*8]
    mov     [rcx+r9*8], r10
    dec     r9
    jmp     %%16
%%12:
    add     r9, -2
    jmp     %%17
    db      0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90
%%13:
    %1      r10, [rdx+r9*8]
    mov     [rcx+r9*8], r10
    inc     r9
    jz      %%18
%%14:
    mov     r10, [r8+r9*8]
    not     r10
%%15:
    mov     r11, [r8+r9*8+8]
    not     r11
    %1      r10, [rdx+r9*8]
    %1      r11, [rdx+r9*8+8]
    mov     [rcx+r9*8], r10
    mov     [rcx+r9*8+8], r11
%%16:
    mov     r10, [r8+r9*8+16]
    not     r10
%%17:
    mov     r11, [r8+r9*8+24]
    not     r11
    %1      r10, [rdx+r9*8+16]
    %1      r11, [rdx+r9*8+24]
    mov     [rcx+r9*8+16], r10
    mov     [rcx+r9*8+24], r11
    add     r9, 4
    jnc     %%14
%%18:
    ret

%endif

%ifidn %3, v3

    mov     r10, [r8]
    mov     eax, r9d
    lea     r8, [r8+r9*8]
    lea     rdx, [rdx+r9*8]
    lea     rcx, [rcx+r9*8]
    neg     r9
    and     eax, 3
    je      %%25
    cmp     eax, 2
    jc      %%23
    je      %%22
%%21:
    %1      r10, [rdx+r9*8]
    not     r10
    mov     [rcx+r9*8], r10
    dec     r9
    jmp     %%26
%%22:
    add     r9, -2
    jmp     %%27
    db      0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90
%%23:
    %1      r10, [rdx+r9*8]
    not     r10
    mov     [rcx+r9*8], r10
    inc     r9
    jz      %%28
%%24:
    mov     r10, [r8+r9*8]
%%25:
    mov     r11, [r8+r9*8+8]
    %1      r10, [rdx+r9*8]
    not     r10
    %1      r11, [rdx+r9*8+8]
    not     r11
    mov     [rcx+r9*8], r10
    mov     [rcx+r9*8+8], r11
%%26:
    mov     r10, [r8+r9*8+16]
%%27:
    mov     r11, [r8+r9*8+24]
    %1      r10, [rdx+r9*8+16]
    not     r10
    %1      r11, [rdx+r9*8+24]
    not     r11
    mov     [rcx+r9*8+16], r10
    mov     [rcx+r9*8+24], r11
    add     r9, 4
    jnc     %%24
%%28:
    ret

%endif

%endmacro

    BITS    64
    SECTION .text

    func and, mpn_and_n,  v1
    func and, mpn_andn_n, v2
    func and, mpn_nand_n, v3
    func  or, mpn_ior_n,  v1
    func  or, mpn_iorn_n, v2
    func  or, mpn_nior_n, v3
    func xor, mpn_xor_n,  v1
    func xor, mpn_xnor_n, v2

    end
