
;  AMD64 mpn_lshift -- mpn left shift.
;  Copyright 2003, 2005, 2007 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;
;  This file is part of the GNU MP Library.
;
;  The GNU MP Library is free software; you can redistribute it and/or
;  modify it under the terms of the GNU Lesser General Public License as
;  published by the Free Software Foundation; either version 3 of the
;  License, or (at your option) any later version.
;
;  The GNU MP Library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;  Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n	rdx
%define 	cnt	rcx

%define reg_save_list rsi, rdi

    BITS    64
	SECTION .text

	xalign  32
	WIN64_GCC_PROC mpn_lshift, 4
	movsxd  rdx, edx
	cmp     cl, 1
	jne     L_gen
	mov     rax, rdi
	sub     rax, rsi
	je      L_fwd
	shr     rax, 3
	cmp     rax, rdx
	jb      L_gen
L_fwd:
	mov     eax, edx
	shr     rdx, 2
	je      L_e1
	and     eax, 3
	
	xalign  8
	nop
	nop
L_t1:
	mov     r8, [rsi]
	mov     r9, [rsi+8]
	mov     r10, [rsi+16]
	mov     r11, [rsi+24]
	lea     rsi, [rsi+32]
	adc     r8, r8
	mov     [rdi], r8
	adc     r9, r9
	mov     [rdi+8], r9
	adc     r10, r10
	mov     [rdi+16], r10
	adc     r11, r11
	mov     [rdi+24], r11
	lea     rdi, [rdi+32]
	dec     rdx
	jne     L_t1
	inc     eax
	dec     eax
	jne     L_n00
	adc     eax, eax
	jmp     L_xit
L_e1:	
    test    eax, eax
L_n00:	
    mov     r8, [rsi]
	dec     eax
	jne     L_n01
	adc     r8, r8
	mov     [rdi], r8
L_ret:	
    adc     eax, eax
	jmp     L_xit
L_n01:	
    dec     eax
	mov     r9, [rsi+8]
	jne     L_n10
	adc     r8, r8
	adc     r9, r9
	mov     [rdi], r8
	mov     [rdi+8], r9
	adc     eax, eax
	jmp     L_xit
	
L_n10:	
    mov     r10, [rsi+16]
	adc     r8, r8
	adc     r9, r9
	adc     r10, r10
	mov     [rdi], r8
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	adc     eax, -1
	jmp     L_xit
L_gen:	
    neg     ecx
	mov     rax, [rsi+rdx*8-8]
	shr     rax, cl
	neg     ecx
	lea     r8d, [rdx+1]
	and     r8d, 3
	je      L_rolx
	dec     r8d
	jne	    L_1
	mov     r10, [rsi+rdx*8-8]
	shl     r10, cl
	neg     ecx
	mov     r8, [rsi+rdx*8-16]
	shr     r8, cl
	or      r10, r8
	mov     [rdi+rdx*8-8], r10
	dec     rdx
	jmp	    L_roll
L_1
	dec     r8d
	je      L_1x
	mov     r10, [rsi+rdx*8-8]
	shl     r10, cl
	neg     ecx
	mov     r8, [rsi+rdx*8-16]
	shr     r8, cl
	or      r10, r8
	mov     [rdi+rdx*8-8], r10
	dec     rdx
	neg     ecx
L_1x:
	cmp     rdx, 1
	je	    L_ast
	mov     r10, [rsi+rdx*8-8]
	shl     r10, cl
	mov     r11, [rsi+rdx*8-16]
	shl     r11, cl
	neg     ecx
	mov     r8, [rsi+rdx*8-16]
	mov     r9, [rsi+rdx*8-24]
	shr     r8, cl
	or      r10, r8
	shr     r9, cl
	or      r11, r9
	mov     [rdi+rdx*8-8], r10
	mov     [rdi+rdx*8-16], r11
	sub     rdx, 2
L_roll:	
	neg     ecx
L_rolx:
	mov     r10, [rsi+rdx*8-8]
	shl     r10, cl
	mov     r11, [rsi+rdx*8-16]
	shl     r11, cl
	sub     rdx, 4
	jb	    L_end
	
	xalign  16
L_oop:
	neg     ecx
	mov     r8, [rsi+rdx*8+16]
	mov     r9, [rsi+rdx*8+8]
	shr     r8, cl
	or      r10, r8
	shr     r9, cl
	or      r11, r9
	mov     [rdi+rdx*8+24], r10
	mov     [rdi+rdx*8+16], r11
	mov     r8, [rsi+rdx*8+0]
	mov     r9, [rsi+rdx*8-8]
	shr     r8, cl
	shr     r9, cl
	neg     ecx
	mov     r10, [rsi+rdx*8+8]
	mov     r11, [rsi+rdx*8+0]
	shl     r10, cl
	or      r8, r10
	shl     r11, cl
	or      r9, r11
	mov     [rdi+rdx*8+8], r8
	mov     [rdi+rdx*8+0], r9
	mov     r10, [rsi+rdx*8-8]
	mov     r11, [rsi+rdx*8-16]
	shl     r10, cl
	shl     r11, cl
	sub     rdx, 4
	jae	    L_oop
L_end:
	neg     ecx
	mov     r8, [rsi+rdx*8+16]
	shr     r8, cl
	or      r10, r8
	mov     r9, [rsi+rdx*8+8]
	shr     r9, cl
	or      r11, r9
	mov     [rdi+rdx*8+24], r10
	mov     [rdi+rdx*8+16], r11
	neg     ecx
L_ast:
	mov     r10, [rsi]
	shl     r10, cl
	mov     [rdi], r10
L_xit:
	WIN64_GCC_END

    end
