
;  AMD64 mpn_lshsub_n.  R = 2^k(U - V).
;  Copyright 2006 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx
%define     cnt r8

%define reg_save_list rbx, rsi, rdi, r12, r13, r14, r15

    BITS    64
	SECTION .text

	xalign  16
	WIN64_GCC_PROC mpn_lshsub_n, 5
	movsxd  rcx, ecx
	mov     rax, rcx
	xor     ebx, ebx
	mov     ecx, r8d
	xor     r15d, r15d
	mov     r11d, eax
	and     r11d, 3
	je      L_4
	sub     r11d, 1
L_oopette:
	add     ebx, ebx
	mov     r8, [rsi+0]
	lea     rsi, [rsi+8]
	sbb     r8, [rdx+0]
	mov     r12, r8
	sbb     ebx, ebx
	shl     r8, cl
	or      r8, r15
	mov     r15, r12
	lea     rdx, [rdx+8]
	neg     cl
	shr     r15, cl
	neg     cl
	mov     [rdi+0], r8
	lea     rdi, [rdi+8]
	sub     r11d, 1
	jnc     L_oopette
L_4:
	sub     rax, 4
	jc      L_end
	
	xalign  16
L_oop:
	add     ebx, ebx
	mov     r8, [rsi+0]
	mov     r9, [rsi+8]
	mov     r10, [rsi+16]
	mov     r11, [rsi+24]
	lea     rsi, [rsi+32]
	sbb     r8, [rdx+0]
	mov     r12, r8
	sbb     r9, [rdx+8]
	mov     r13, r9
	sbb     r10, [rdx+16]
	mov     r14, r10
	sbb     r11, [rdx+24]
	sbb     ebx, ebx
	shl     r8, cl
	shl     r9, cl
	shl     r10, cl
	or      r8, r15
	mov     r15, r11
	shl     r11, cl
	lea     rdx, [rdx+32]
	neg     cl
	shr     r12, cl
	shr     r13, cl
	shr     r14, cl
	shr     r15, cl
	or      r9, r12
	or      r10, r13
	or      r11, r14
	neg     cl
	mov     [rdi+0], r8
	mov     [rdi+8], r9
	mov     [rdi+16], r10
	mov     [rdi+24], r11
	lea     rdi, [rdi+32]
	sub     rax, 4
	jnc     L_oop
L_end:
	neg     ebx
	shl     rbx, cl
	adc     rbx, r15
	mov     rax, rbx
	WIN64_GCC_END

    end
