
;  AMD64 mpn_modexact_1_odd -- exact division style remainder.
;  Copyright 2000, 2001, 2002, 2003, 2004, 2005, 2006 Free Software
;  Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;
;  This file is part of the GNU MP Library.
;
;  The GNU MP Library is free software; you can redistribute it and/or
;  modify it under the terms of the GNU Lesser General Public License as
;  published by the Free Software Foundation; either version 3 of the
;  License, or (at your option) any later version.
;
;  The GNU MP Library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;  Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

;	mp_limb_t mpn_modexact_1_odd (mp_srcptr src, mp_size_t size, mp_limb_t divisor);
;	mp_limb_t mpn_modexact_1c_odd (mp_srcptr src, mp_size_t size, mp_limb_t divisor, mp_limb_t carry);

%define reg_save_list rsi, rdi

    BITS    64
	SECTION .text

    extern  __gmp_binvert_limb_table

	xalign  32
	WIN64_GCC_PROC mpn_modexact_1_odd, 0, leaf
	mov     r9, 0
	WIN64_GCC_PROC mpn_modexact_1c_odd, 3
	movsxd  rsi, esi
	mov     rcx, r9

    mov     r8, rdx
    shr     edx, 1
	lea     r9, [rel __gmp_binvert_limb_table]
	and     edx, 127
	mov     r10, rcx
	movzx   edx, byte [r9+rdx]
	mov     rax, [rdi]
	lea     r11, [rdi+rsi*8]
	mov     rdi, r8
	lea     ecx, [rdx+rdx]
	imul    edx, edx
	neg     rsi
	imul    edx, edi
	sub     ecx, edx
	lea     edx, [rcx+rcx]
	imul    ecx, ecx
	imul    ecx, edi
	sub     edx, ecx
	xor     ecx, ecx
	lea     r9, [rdx+rdx]
	imul    rdx, rdx
	imul    rdx, r8
	sub     r9, rdx
	mov     rdx, r10
	mov     r10, r8
	imul    r10, r9
	cmp     r10, 1
	inc     rsi
	jz      L_one

	xalign  16
L_top:
	sub     rax, rdx
	adc     rcx, 0
	imul    rax, r9
	mul     r8
	mov     rax, [r11+rsi*8]
	sub     rax, rcx
	setc    cl
	inc     rsi
	jnz     L_top
L_one:
	sub     rax, rdx
	adc     rcx, 0
	imul    rax, r9
	mul     r8
	lea     rax, [rcx+rdx]
	WIN64_GCC_END

    end
