
;  AMD64 mpn_mul_1.
;  Copyright 2003, 2004, 2005, 2007, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n_param	rdx
%define 	vl	rcx
%define 	n	r11

%define reg_save_list rbx, rsi, rdi

    BITS    64
	SECTION .text
	
	xalign  16
	WIN64_GCC_PROC mpn_mul_1c, 0, leaf
	mov     r10, [rsp+0x28]
	jmp     L_common

	WIN64_GCC_PROC mpn_mul_1, 0, leaf
	xor     r10, r10
L_common:

WIN64_GCC_PROC mpn_mul_x, 4
	movsxd  rdx, edx
	
	mov     rax, [rsi]
	mov     rbx, rdx
	mul     rcx
	mov     r11, rbx
	add     rax, r10
	adc     rdx, 0
	and     ebx, 3
	jz      L_b0
	cmp     ebx, 2
	jz      L_b2
	jg      L_b3
L_b1:	
    dec     r11
	jne     L_gt1
	mov     [rdi], rax
	jmp     L_ret
L_gt1:
	lea     rsi, [rsi+r11*8+8]
	lea     rdi, [rdi+r11*8-8]
	neg     r11
	xor     r10, r10
	xor     ebx, ebx
	mov     r9, rax
	mov     rax, [rsi+r11*8]
	mov     r8, rdx
	jmp     L_L1
L_b0:
	lea     rsi, [rsi+r11*8]
	lea     rdi, [rdi+r11*8-16]
	neg     r11
	xor     r10, r10
	mov     r8, rax
	mov     rbx, rdx
	jmp     L_L0
L_b3:
	lea     rsi, [rsi+r11*8-8]
	lea     rdi, [rdi+r11*8-24]
	neg     r11
	mov     rbx, rax
	mov     r10, rdx
	jmp     L_L3
L_b2:
	lea     rsi, [rsi+r11*8-16]
	lea     rdi, [rdi+r11*8-32]
	neg     r11
	xor     r8, r8
	xor     ebx, ebx
	mov     r10, rax
	mov     rax, [rsi+r11*8+24]
	mov     r9, rdx
	jmp     L_L2
	
	xalign  16
L_top:
	mov     [rdi+r11*8], r10
	add     r9, rax
	mov     rax, [rsi+r11*8]
	adc     r8, rdx
	mov     r10d, 0
L_L1:
	mul     rcx
	mov     [rdi+r11*8+8], r9
	add     r8, rax
	adc     rbx, rdx
L_L0:
	mov     rax, [rsi+r11*8+8]
	mul     rcx
	mov     [rdi+r11*8+16], r8
	add     rbx, rax
	adc     r10, rdx
L_L3:
	mov     rax, [rsi+r11*8+16]
	mul     rcx
	mov     [rdi+r11*8+24], rbx
	mov	    r8d, 0
	mov	    rbx, r8
	add     r10, rax
	mov     rax, [rsi+r11*8+24]
	mov	    r9, r8
	adc     r9, rdx
L_L2:
	mul     rcx
	add     r11, 4
	js      L_top
	mov     [rdi+r11*8], r10
	add     r9, rax
	adc     rdx, r8
	mov     [rdi+r11*8+8], r9
	add     rdx, r8
L_ret:	
    mov     rax, rdx
	WIN64_GCC_END

    end
