
;  AMD64 mpn_mul_2 -- Multiply an n-limb vector with a 2-limb vector and
;  store the result in a third limb vector.
;  Copyright 2008 Free Software Foundation, Inc.
;  This file is part of the GNU MP Library.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n_param	rdx
%define 	vp	rcx
%define 	v0	r8
%define 	v1	r9
%define 	w0	rbx
%define 	w1	rcx
%define 	w2	rbp
%define 	w3	r10
%define 	n	r11

%define reg_save_list rbx, rbp, rsi, rdi

    BITS    64
	SECTION .text

	xalign  16
	WIN64_GCC_PROC mpn_mul_2, 4
	movsxd  rdx, edx
	
	mov     r8, [rcx]
	mov     r9, [rcx+8]
	mov     rax, [rsi]
	mov     r11, rdx
	neg     r11
	lea     rsi, [rsi+rdx*8-8]
	lea     rdi, [rdi+rdx*8-8]
	and     edx, 3
	jz      L_m2p0
	cmp     edx, 2
	jc      L_m2p1
	jz      L_m2p2
L_m2p3:
	mul     r8
	xor     r10d, r10d
	mov     rcx, rax
	mov     rbp, rdx
	mov     rax, [rsi+r11*8+8]
	add     r11, -1
	mul     r9
	add     rbp, rax
	jmp     L_m23
L_m2p0:
	mul     r8
	xor     ebp, ebp
	mov     rbx, rax
	mov     rcx, rdx
	jmp     L_m20
L_m2p1:
	mul     r8
	xor     r10d, r10d
	xor     ebx, ebx
	xor     ecx, ecx
	add     r11, 1
	jmp     L_m2top
L_m2p2:
	mul     r8
	xor     ebx, ebx
	xor     ecx, ecx
	mov     rbp, rax
	mov     r10, rdx
	mov     rax, [rsi+r11*8+8]
	add     r11, -2
	jmp     L_m22
	xalign  32
L_m2top:
	add     r10, rax
	adc     rbx, rdx
	mov     rax, [rsi+r11*8+0]
	adc     ecx, 0
	mov     ebp, 0
	mul     r9
	add     rbx, rax
	mov     [rdi+r11*8+0], r10
	adc     rcx, rdx
	mov     rax, [rsi+r11*8+8]
	mul     r8
	add     rbx, rax
	adc     rcx, rdx
	adc     ebp, 0
L_m20:	
    mov     rax, [rsi+r11*8+8]
	mul     r9
	add     rcx, rax
	adc     rbp, rdx
	mov     rax, [rsi+r11*8+16]
	mov     r10d, 0
	mul     r8
	add     rcx, rax
	mov     rax, [rsi+r11*8+16]
	adc     rbp, rdx
	adc     r10d, 0
	mul     r9
	add     rbp, rax
	mov     [rdi+r11*8+8], rbx
L_m23:
	adc     r10, rdx
	mov     rax, [rsi+r11*8+24]
	mul     r8
	mov     ebx, 0
	add     rbp, rax
	adc     r10, rdx
	mov     [rdi+r11*8+16], rcx
	mov     rax, [rsi+r11*8+24]
	mov     ecx, 0
	adc     ebx, 0
L_m22:
	mul     r9
	add     r10, rax
	mov     [rdi+r11*8+24], rbp
	adc     rbx, rdx
	mov     rax, [rsi+r11*8+32]
	mul     r8
	add     r11, 4
	js      L_m2top
	add     r10, rax
	adc     rbx, rdx
	adc     ecx, 0
	mov     rax, [rsi]
	mul     r9
	mov     [rdi], r10
	add     rbx, rax
	adc     rcx, rdx
	mov     [rdi+8], rbx
	mov     rax, rcx
	WIN64_GCC_END

    end
