
;  AMD64 mpn_mul_basecase.
;  Contributed to the GNU project by Torbjorn Granlund and David Harvey.
;  Copyright 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	un_param	rdx
%define 	vp	rcx
%define 	vn	r8
%define 	v0	r12
%define 	v1	r9
%define 	w0	rbx
%define 	w1	r15
%define 	w2	rbp
%define 	w3	r10
%define 	n	r11
%define 	outer_addr	r14
%define 	un	r13

%define reg_save_list rbx, rbp, rsi, rdi, r12, r13, r14, r15

    BITS    64
	SECTION .text

	xalign  16
	WIN64_GCC_PROC mpn_mul_basecase, 5
	movsxd  rdx, edx
	movsxd  r8, r8d
	
	xor     r13d, r13d
	mov     rax, [rsi]
	mov     r12, [rcx]
	sub     r13, rdx
	mov     r11, r13
	mov     ebx, edx
	lea     rdi, [rdi+rdx*8]
	lea     rsi, [rsi+rdx*8]
	mul     r12
	test    r8, 1
	jz      L_mul_2
L_mul_1:
	and     ebx, 3
	jz      L_mul_1_prologue_0
	cmp     ebx, 2
	jc      L_mul_1_prologue_1
	jz      L_mul_1_prologue_2
	jmp     L_mul_1_prologue_3
L_mul_1_prologue_0:
	mov     rbp, rax
	mov     r10, rdx
	lea     r14, [rel L_addmul_outer_0]
	jmp     L_mul_1_entry_0
L_mul_1_prologue_1:
	cmp     r13, -1
	jne	    .1
	mov     [rdi-8], rax
	mov     [rdi], rdx
	jmp     L_ret
.1:	add     r11, 1
	lea     r14, [rel L_addmul_outer_1]
	mov     r15, rax
	mov     rbp, rdx
	xor     r10d, r10d
	mov     rax, [rsi+r11*8]
	jmp     L_mul_1_entry_1
L_mul_1_prologue_2:
	add     r11, -2
	lea     r14, [rel L_addmul_outer_2]
	mov     rbx, rax
	mov     r15, rdx
	mov     rax, [rsi+r11*8+24]
	xor     ebp, ebp
	xor     r10d, r10d
	jmp     L_mul_1_entry_2
L_mul_1_prologue_3:
	add     r11, -1
	lea     r14, [rel L_addmul_outer_3]
	mov     r10, rax
	mov     rbx, rdx
	jmp     L_mul_1_entry_3
	
	xalign  16
L_mul_1_top:
	mov     [rdi+r11*8-16], rbx
	add     r15, rax
	mov     rax, [rsi+r11*8]
	adc     rbp, rdx
L_mul_1_entry_1:
	xor     ebx, ebx
	mul     r12
	mov     [rdi+r11*8-8], r15
	add     rbp, rax
	adc     r10, rdx
L_mul_1_entry_0:
	mov     rax, [rsi+r11*8+8]
	mul     r12
	mov     [rdi+r11*8], rbp
	add     r10, rax
	adc     rbx, rdx
L_mul_1_entry_3:
	mov     rax, [rsi+r11*8+16]
	mul     r12
	mov     [rdi+r11*8+8], r10
	xor     ebp, ebp
	mov     r10, rbp
	add     rbx, rax
	mov     rax, [rsi+r11*8+24]
	mov     r15, rbp
	adc     r15, rdx
L_mul_1_entry_2:
	mul     r12
	add     r11, 4
	js      L_mul_1_top
	mov     [rdi-16], rbx
	add     r15, rax
	mov     [rdi-8], r15
	adc     rbp, rdx
	mov     [rdi], rbp
	add     r8, -1
	jz      L_ret
	mov     r12, [rcx+8]
	mov     r9, [rcx+16]
	lea     rcx, [rcx+8]
	lea     rdi, [rdi+8]
	jmp     r14
	
	xalign  16
L_mul_2:
	mov     r9, [rcx+8]
	and     ebx, 3
	jz      L_mul_2_prologue_0
	cmp     ebx, 2
	jz      L_mul_2_prologue_2
	jc      L_mul_2_prologue_1
L_mul_2_prologue_3:
	lea     r14, [rel L_addmul_outer_3]
	add     r11, 2
	mov     [rdi+r11*8-16], rax
	mov     rbp, rdx
	xor     r10d, r10d
	xor     ebx, ebx
	mov     rax, [rsi+r11*8-16]
	jmp     L_mul_2_entry_3
	xalign  16
L_mul_2_prologue_0:
	add     r11, 3
	mov     rbx, rax
	mov     r15, rdx
	xor     ebp, ebp
	mov     rax, [rsi+r11*8-24]
	lea     r14, [rel L_addmul_outer_0]
	jmp     L_mul_2_entry_0
	
	xalign  16
L_mul_2_prologue_1:
	mov     r10, rax
	mov     rbx, rdx
	xor     r15d, r15d
	lea     r14, [rel L_addmul_outer_1]
	jmp     L_mul_2_entry_1
	
	xalign  16
L_mul_2_prologue_2:
	add     r11, 1
	lea     r14, [rel L_addmul_outer_2]
	mov     ebx, 0
	mov     r15d, 0
	mov     rbp, rax
	mov     rax, [rsi+r11*8-8]
	mov     r10, rdx
	jmp     L_mul_2_entry_2

	xalign  16
L_mul_2_top:
	mov     rax, [rsi+r11*8-32]
	mul     r9
	add     rbx, rax
	adc     r15, rdx
	mov     rax, [rsi+r11*8-24]
	xor     ebp, ebp
	mul     r12
	add     rbx, rax
	mov     rax, [rsi+r11*8-24]
	adc     r15, rdx
	adc     ebp, 0
L_mul_2_entry_0:
	mul     r9
	add     r15, rax
	mov     [rdi+r11*8-24], rbx
	adc     rbp, rdx
	mov     rax, [rsi+r11*8-16]
	mul     r12
	mov     r10d, 0
	add     r15, rax
	adc     rbp, rdx
	mov     rax, [rsi+r11*8-16]
	adc     r10d, 0
	mov     ebx, 0
	mov     [rdi+r11*8-16], r15
L_mul_2_entry_3:
	mul     r9
	add     rbp, rax
	mov     rax, [rsi+r11*8-8]
	adc     r10, rdx
	mov     r15d, 0
	mul     r12
	add     rbp, rax
	mov     rax, [rsi+r11*8-8]
	adc     r10, rdx
	adc	    ebx, r15d
L_mul_2_entry_2:
	mul     r9
	add     r10, rax
	mov     [rdi+r11*8-8], rbp
	adc     rbx, rdx
	mov     rax, [rsi+r11*8]
	mul     r12
	add     r10, rax
	adc     rbx, rdx
	adc     r15d, 0
L_mul_2_entry_1:
	add     r11, 4
	mov     [rdi+r11*8-32], r10
	js      L_mul_2_top
	mov     rax, [rsi+r11*8-32]
	mul     r9
	add     rbx, rax
	mov     [rdi], rbx
	adc     r15, rdx
	mov     [rdi+8], r15
	add     r8, -2
	jz      L_ret
	mov     r12, [rcx+16]
	mov     r9, [rcx+24]
	lea     rcx, [rcx+16]
	lea     rdi, [rdi+16]
	jmp     r14
	
L_addmul_outer_0:
	add     r13, 3
	lea     r14, [rip+0]
	mov     r11, r13
	mov     rax, [rsi+r13*8-24]
	mul     r12
	mov     rbx, rax
	mov     rax, [rsi+r13*8-24]
	mov     r15, rdx
	xor     ebp, ebp
	jmp     L_addmul_entry_0
L_addmul_outer_1:
	mov     r11, r13
	mov     rax, [rsi+r13*8]
	mul     r12
	mov     r10, rax
	mov     rax, [rsi+r13*8]
	mov     rbx, rdx
	xor     r15d, r15d
	jmp     L_addmul_entry_1
L_addmul_outer_2:
	add     r13, 1
	lea     r14, [rip+0]
	mov     r11, r13
	mov     rax, [rsi+r13*8-8]
	mul     r12
	xor     ebx, ebx
	mov     rbp, rax
	xor     r15d, r15d
	mov     r10, rdx
	mov     rax, [rsi+r13*8-8]
	jmp     L_addmul_entry_2
L_addmul_outer_3:
	add     r13, 2
	lea     r14, [rip+0]
	mov     r11, r13
	mov     rax, [rsi+r13*8-16]
	xor     r10d, r10d
	mul     r12
	mov     r15, rax
	mov     rax, [rsi+r13*8-16]
	mov     rbp, rdx
	jmp     L_addmul_entry_3
	
	xalign  16
L_addmul_top:
	add     [rdi+r11*8-32], r10
	adc     rbx, rax
	mov     rax, [rsi+r11*8-24]
	adc     r15, rdx
	xor     ebp, ebp
	mul     r12
	add     rbx, rax
	mov     rax, [rsi+r11*8-24]
	adc     r15, rdx
	adc     ebp, ebp
L_addmul_entry_0:
	mul     r9
	xor     r10d, r10d
	add     [rdi+r11*8-24], rbx
	adc     r15, rax
	mov     rax, [rsi+r11*8-16]
	adc     rbp, rdx
	mul     r12
	add     r15, rax
	mov     rax, [rsi+r11*8-16]
	adc     rbp, rdx
	adc     r10d, 0
L_addmul_entry_3:
	mul     r9
	add     [rdi+r11*8-16], r15
	adc     rbp, rax
	mov     rax, [rsi+r11*8-8]
	adc     r10, rdx
	mul     r12
	xor     ebx, ebx
	add     rbp, rax
	adc     r10, rdx
	mov     r15d, 0
	mov     rax, [rsi+r11*8-8]
	adc	    ebx, r15d
L_addmul_entry_2:
	mul     r9
	add     [rdi+r11*8-8], rbp
	adc     r10, rax
	adc     rbx, rdx
	mov     rax, [rsi+r11*8]
	mul     r12
	add     r10, rax
	mov     rax, [rsi+r11*8]
	adc     rbx, rdx
	adc     r15d, 0
L_addmul_entry_1:
	mul     r9
	add     r11, 4
	js      L_addmul_top
	add     [rdi-8], r10
	adc     rbx, rax
	mov     [rdi], rbx
	adc     r15, rdx
	mov     [rdi+8], r15
	add     r8, -2
	jz      L_ret
	lea     rdi, [rdi+16]
	lea     rcx, [rcx+16]
	mov     r12, [rcx]
	mov     r9, [rcx+8]
	jmp     r14
	
	xalign  16
L_ret:
	WIN64_GCC_END

    end
