
;  x86-64 mpn_add_n/mpn_sub_n optimized for Pentium 4.
;  Copyright 2007, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "..\yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx
%define 	cy	r8

%macro  func 3

	xalign  16
	WIN64_GCC_PROC %2, frame_fun, 5
	movsxd  rcx, ecx
	jmp     %%1

	xalign  16
	WIN64_GCC_PROC %3, frame_fun, 4
	movsxd  rcx, ecx
	xor     r8, r8

%%1:	
	mov     r9, [rdx]
	mov     eax, ecx
	and     eax, 3
	jne     %%2
	mov     ebx, r8d
	mov     r8, [rsi]
	mov     r10, [rsi+8]
	%1      r8, r9
	mov     r9, [rdx+8]
	setc    al
	lea     rdi, [rdi-16]
	jmp     %%14
%%2:	
    cmp     eax, 2
	jnc     %%4
	mov     r11, [rsi]
	mov     eax, r8d
	xor     ebx, ebx
	dec     rcx
	jnz     %%3
	%1      r11, r9
	setc    bl
	%1      r11, rax
	adc     ebx, 0
	mov     [rdi], r11
	jmp     %%22
%%3:
	mov     r8, [rsi+8]
	%1      r11, r9
	mov     r9, [rdx+8]
	setc    bl
	lea     rdi, [rdi-8]
	lea     rsi, [rsi+8]
	lea     rdx, [rdx+8]
	jmp     %%12
%%4:
    jne     %%5
	mov     r12, [rsi]
	mov     ebx, r8d
	mov     r11, [rsi+8]
	%1      r12, r9
	mov     r9, [rdx+8]
	setc    al
	lea     rdi, [rdi-32]
	lea     rsi, [rsi+16]
	lea     rdx, [rdx+16]
	jmp     %%18
%%5:
	mov     r10, [rsi]
	mov     eax, r8d
	xor     ebx, ebx
	mov     r12, [rsi+8]
	%1      r10, r9
	mov     r9, [rdx+8]
	setc    bl
	lea     rdi, [rdi-24]
	lea     rsi, [rsi-8]
	lea     rdx, [rdx-8]
	jmp     %%16
%%7:	
    mov     bl, 1
	jmp     %%13
%%8:
	mov     al, 1
	jmp     %%15
%%9:	
    mov     bl, 1
	jmp     %%17
%%10:
   	mov     al, 1
	jmp     %%19

	xalign  16
%%11:
	mov     r8, [rsi]
	%1      r11, r9
	mov     r9, [rdx]
	setc    bl
	mov     [rdi], r12
%%12:	
    %1      r11, rax
	jc      %%7
%%13:
	mov     r10, [rsi+8]
	%1      r8, r9
	mov     r9, [rdx+8]
	setc    al
	mov     [rdi+8], r11
%%14:
	%1      r8, rbx
	jc      %%8
%%15:
	mov     r12, [rsi+16]
	%1      r10, r9
	mov     r9, [rdx+16]
	setc    bl
	mov     [rdi+16], r8
%%16:
	%1      r10, rax
	jc      %%9
%%17:
	mov     r11, [rsi+24]
	%1      r12, r9
	lea     rsi, [rsi+32]
	mov     r9, [rdx+24]
	lea     rdx, [rdx+32]
	setc    al
	mov     [rdi+24], r10
%%18:
	%1      r12, rbx
	jc      %%10
%%19:
	lea     rdi, [rdi+32]
	sub     rcx, 4
	ja      %%11
%%20:
	%1      r11, r9
	setc    bl
	mov     [rdi], r12
	%1      r11, rax
	jnc     %%21
	mov     bl, 1
%%21:
	mov     [rdi+8], r11
%%22:
	mov     eax, ebx
	WIN64_GCC_END

%endmacro
	
%define reg_save_list rbx, rsi, rdi, r12
%stack_slots          0

    BITS    64
	TEXT

    func    add, mpn_add_nc, mpn_add_n
    func    sub, mpn_sub_nc, mpn_sub_n
   
    end
