
;  AMD64 mpn_addlsh1_n, mpn_sublsh1_n -- rp[] = up[] +- (vp[] << 1),
;  optimized for Pentium 4.
;  Copyright 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "..\yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx

%macro  func 2

	xalign  16
	WIN64_GCC_PROC %2, frame_fun, 4
	movsxd  rcx, ecx

	mov     r9, [rdx]
	shl     r9
	mov     ebp, [rdx+4]
	xor     ebx, ebx
	mov     eax, ecx
	and     eax, 3
	jne     %%1
	mov     r8, [rsi]
	mov     r10, [rsi+8]
	shr     ebp, 31
	%1      r8, r9
	mov     r9, [rdx+8]
	lea     r9, [rbp+r9*2]
	setc    al
	mov     ebp, [rdx+12]
	lea     rdi, [rdi-16]
	jmp     %%9
%%1:	
    cmp     eax, 2
    jnc     %%2
	mov     r11, [rsi]
	lea     rdi, [rdi-8]
	shr     ebp, 31
	%1      r11, r9
	setc    bl
	dec     rcx
	jz      %%14
	mov     r8, [rsi+8]
	mov     r9, [rdx+8]
	lea     r9, [rbp+r9*2]
	mov     ebp, [rdx+12]
	lea     rsi, [rsi+8]
	lea     rdx, [rdx+8]
	jmp     %%8
%%2:
    jne     %%3
	mov     r12, [rsi]
	mov     r11, [rsi+8]
	shr     ebp, 31
	%1      r12, r9
	mov     r9, [rdx+8]
	lea     r9, [rbp+r9*2]
	setc    al
	mov     ebp, [rdx+12]
	lea     rsi, [rsi+16]
	lea     rdx, [rdx+16]
	jmp     %%12
%%3:	
    mov     r10, [rsi]
	mov     r12, [rsi+8]
	shr     ebp, 31
	%1      r10, r9
	mov     r9, [rdx+8]
	lea     r9, [rbp+r9*2]
	setc    bl
	mov     ebp, [rdx+12]
	lea     rdi, [rdi-24]
	lea     rsi, [rsi-8]
	lea     rdx, [rdx-8]
	jmp     %%10
%%4:	
    mov     bl, 1
	jmp     %%8
%%5:
	mov     al, 1
	jmp     %%9
%%6:
	mov     bl, 1
	jmp     %%10
	
	xalign  16
%%7:
	mov     r8, [rsi]
	shr     ebp, 31
	%1      r11, r9
	mov     r9, [rdx]
	lea     r9, [rbp+r9*2]
	setc    bl
	mov     ebp, [rdx+4]
	mov     [rdi], r12
	%1      r11, rax
	jc      %%4
%%8:
	mov     r10, [rsi+8]
	shr     ebp, 31
	%1      r8, r9
	mov     r9, [rdx+8]
	lea     r9, [rbp+r9*2]
	setc    al
	mov     ebp, [rdx+12]
	mov     [rdi+8], r11
	%1      r8, rbx
	jc      %%5
%%9:	
    mov     r12, [rsi+16]
	shr     ebp, 31
	%1      r10, r9
	mov     r9, [rdx+16]
	lea     r9, [rbp+r9*2]
	setc    bl
	mov     ebp, [rdx+20]
	mov     [rdi+16], r8
	%1      r10, rax
	jc      %%6
%%10:	
    mov     r11, [rsi+24]
	shr     ebp, 31
	%1      r12, r9
	mov     r9, [rdx+24]
	lea     r9, [rbp+r9*2]
	lea     rsi, [rsi+32]
	lea     rdx, [rdx+32]
	setc    al
	mov     ebp, [rdx-4]
	mov     [rdi+24], r10
	%1      r12, rbx
	jc      %%15
%%11:
	lea     rdi, [rdi+32]
%%12:
	sub     rcx, 4
	ja      %%7
%%13:
	shr     ebp, 31
	%1      r11, r9
	setc    bl
	mov     [rdi], r12
	%1      r11, rax
	jnc     %%14
	mov     bl, 1
%%14:
	mov     [rdi+8], r11
	lea     eax, [rbx+rbp]
	emms
    jmp     %%16
%%15:
    mov     al, 1
	jmp     %%11
%%16:
	WIN64_GCC_END

%endmacro

%define reg_save_list rbx, rbp, rsi, rdi, r12
%stack_slots          0

    BITS    64
	TEXT

    func add, mpn_addlsh1_n
    func sub, mpn_sublsh1_n
    
    end
