
;  x86-64 mpn_rshift optimized for Pentium 4.
;  Copyright 2003, 2005, 2007, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;
;  This file is part of the GNU MP Library.
;
;  The GNU MP Library is free software; you can redistribute it and/or
;  modify it under the terms of the GNU Lesser General Public License as
;  published by the Free Software Foundation; either version 3 of the
;  License, or (at your option) any later version.
;
;  The GNU MP Library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;  Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "..\yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n	rdx
%define 	cnt	cl

%define reg_save_list rsi, rdi
%stack_slots          0

    BITS    64
	TEXT

	xalign  16
	WIN64_GCC_PROC mpn_rshift, frame_fun, 4
	movsxd  rdx, edx

	mov     rax, [rsi]
	movd    mm4, ecx
	neg     ecx
	and     ecx, 63
	movd    mm5, ecx
	lea     rsi, [rsi+rdx*8-8]
	lea     rdi, [rdi+rdx*8-8]
	lea     r8d, [rdx+1]
	neg     rdx
	shl     rax, cl
	and     r8d, 3
	je      L_rol
	dec     r8d
	jne     L_1
	movq    mm2, [rsi+rdx*8+8]
	psrlq   mm2, mm4
	movq    mm0, [rsi+rdx*8+16]
	psllq   mm0, mm5
	por     mm2, mm0
	movq    [rdi+rdx*8+8], mm2
	inc     rdx
	jmp     L_rol
L_1:
	dec     r8d
	je      L_1x
	movq    mm2, [rsi+rdx*8+8]
	psrlq   mm2, mm4
	movq    mm0, [rsi+rdx*8+16]
	psllq   mm0, mm5
	por     mm2, mm0
	movq    [rdi+rdx*8+8], mm2
	inc     rdx
L_1x:
	cmp     rdx, -1
	je      L_ast
	movq    mm2, [rsi+rdx*8+8]
	psrlq   mm2, mm4
	movq    mm3, [rsi+rdx*8+16]
	psrlq   mm3, mm4
	movq    mm0, [rsi+rdx*8+16]
	movq    mm1, [rsi+rdx*8+24]
	psllq   mm0, mm5
	por     mm2, mm0
	psllq   mm1, mm5
	por     mm3, mm1
	movq    [rdi+rdx*8+8], mm2
	movq    [rdi+rdx*8+16], mm3
	add     rdx, 2
L_rol:	
    movq    mm2, [rsi+rdx*8+8]
	psrlq   mm2, mm4
	movq    mm3, [rsi+rdx*8+16]
	psrlq   mm3, mm4
	add     rdx, 4
	jb      L_end
	
	xalign  32
L_top:

	movq    mm0, [rsi+rdx*8-16]
	movq    mm1, [rsi+rdx*8-8]
	psllq   mm0, mm5
	por     mm2, mm0
	psllq   mm1, mm5
	movq    mm0, [rsi+rdx*8]
	por     mm3, mm1
	movq    mm1, [rsi+rdx*8+8]
	movq    [rdi+rdx*8-24], mm2
	movq    [rdi+rdx*8-16], mm3

	psllq   mm0, mm5
	psllq   mm1, mm5

	movq    mm2, [rsi+rdx*8-8]
	movq    mm3, [rsi+rdx*8]
	psrlq   mm2, mm4
	por     mm0, mm2
	psrlq   mm3, mm4
	movq    mm2, [rsi+rdx*8+8]
	por     mm1, mm3
	movq    mm3, [rsi+rdx*8+16]
	movq    [rdi+rdx*8-8], mm0
	movq    [rdi+rdx*8], mm1

	add     rdx, 4
	psrlq   mm2, mm4
	psrlq   mm3, mm4
	jae     L_top
L_end:
	movq    mm0, [rsi+rdx*8-16]
	psllq   mm0, mm5
	por     mm2, mm0
	movq    mm1, [rsi+rdx*8-8]
	psllq   mm1, mm5
	por     mm3, mm1
	movq    [rdi+rdx*8-24], mm2
	movq    [rdi+rdx*8-16], mm3
L_ast:
	movq    mm2, [rsi]
	psrlq   mm2, mm4
	movq    [rdi], mm2
	emms
	WIN64_GCC_END
	
	end
