
;  AMD64 mpn_popcount, mpn_hamdist -- population count and hamming distance.
;  Copyright 2004, 2005, 2007 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%macro  func    1

%ifidn %1, ham

%define reg_save_list   rsi, rdi, r12, r13, r14

%define 	    up	    rdi
%define 	    vp	    rsi
%define 	    n	    rdx
%define 	    reg_55  r10
%define 	    reg_33	r11
%define 	    reg_0f  rcx
%define 	    reg_01  r14

	xalign  32
	WIN64_GCC_PROC mpn_hamdist, 3  
	movsxd  rdx, edx

%else

%define reg_save_list   rsi, rdi, r12, r13

%define 	    up	    rdi
%define 	    n	    rsi
%define 	    reg_55  r10
%define 	    reg_33	r11
%define 	    reg_0f	rcx
%define 	    reg_01	rdx

	xalign  32
	WIN64_GCC_PROC mpn_popcount, 2  
    movsxd  rsi, esi
    
%endif

	mov     reg_55, 0x5555555555555555
	mov     reg_33, 0x3333333333333333
	mov     reg_0f, 0x0f0f0f0f0f0f0f0f
	mov     reg_01, 0x0101010101010101
	lea     up, [up+n*8]
%ifidn %1, ham
	lea     vp, [vp+n*8]
%endif
	neg     n
	xor     eax, eax
	bt      n, 0
	jnc     .1
	mov     r8, [up+n*8]
%ifidn %1, ham
	xor     r8, [vp+n*8]
%endif
	mov     r9, r8
	shr     r8, 1
	and     r8, reg_55
	sub     r9, r8
	
	mov     r8, r9
	shr     r9, 2
	and     r8, reg_33
	and     r9, reg_33
	add     r9, r8
	
	mov     r8, r9
	shr     r9, 4
	and     r8, reg_0f
	and     r9, reg_0f
	add     r9, r8
	
	imul    r9, reg_01
	shr     r9, 56
	add     rax, r9
	add     n, 1
	jz      .2
	
	xalign  16
.1:
	mov     r8, [up+n*8]
	mov     r12, [up+n*8+8]
%ifidn %1, ham
	xor     r8, [vp+n*8]
	xor     r12, [vp+n*8+8]
%endif
	mov     r9, r8
	mov     r13, r12
	shr     r8, 1
	shr     r12, 1
	and     r8, reg_55
	and     r12, reg_55
	sub     r9, r8
	sub     r13, r12
	
	mov     r8, r9
	mov     r12, r13
	shr     r9, 2
	shr     r13, 2
	and     r8, reg_33
	and     r9, reg_33
	and     r12, reg_33
	and     r13, reg_33
	add     r9, r8
	add     r13, r12
	
	add     r9, r13
	mov     r8, r9
	shr     r9, 4
	and     r8, reg_0f
	and     r9, reg_0f
	add     r9, r8
	imul    r9, reg_01
	shr     r9, 56
	add     rax, r9
	add     n, 2
	jnc     .1
.2:
	WIN64_GCC_END

%endmacro

    BITS    64
    SECTION .text

    func ham
    func popcnt
    
    end
