
;  AMD64 mpn_redc_1 -- Montgomery reduction with a one-limb modular inverse.
;  Copyright 2004, 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;
;  This file is part of the GNU MP Library.
;
;  The GNU MP Library is free software; you can redistribute it and/or
;  modify it under the terms of the GNU Lesser General Public License as
;  published by the Free Software Foundation; either version 3 of the
;  License, or (at your option) any later version.
;
;  The GNU MP Library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;  Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	        rdi
%define 	up	        rsi
%define 	param_mp	rdx
%define 	n	        rcx
%define 	invm	    r8
%define 	mp	        r13
%define 	i	        r11
%define 	nneg	    r12

%define reg_save_list rbx, rbp, rsi, rdi, r12, r13, r14

    BITS    64    
	SECTION .text

    extern  __gmpn_add_n
    extern  __gmpn_sub_n
    
	xalign  32
	WIN64_GCC_PROC mpn_redc_1, 5
	movsxd  rcx, ecx
	mov     [rsp+stack_use+0x20], rcx
	
	lea     r13, [rdx+rcx*8]
	lea     rsi, [rsi+rcx*8]
	mov     r12, rcx
	neg     r12
	mov     eax, ecx
	and     eax, 3
	jz      L_b0
	cmp     eax, 2
	jz      L_b2
	jg      L_b3
L_b1:	
	lea     rsi, [rsi-16]
L_o1:
	mov     r11, r12
	mov     rbp, [rsi+r12*8+16]
	imul    rbp, r8
	mov     rax, [r13+r11*8]
	xor     ebx, ebx
	mul     rbp
	add     r11, 1
	jnz	    .1
	add     [rsi+r11*8+8], rax
	adc     rdx, 0
	mov     r14, rdx
	jmp     L_n1
	
.1  mov     r9, rax
	mov     rax, [r13+r11*8]
	mov     r14, rdx
	jmp     L_mi1
	
	xalign  16
L_lo1:
	add     [rsi+r11*8], r10
	adc     r9, rax
	mov     rax, [r13+r11*8]
	adc     r14, rdx
L_mi1:
	xor     r10d, r10d
	mul     rbp
	add     [rsi+r11*8+8], r9
	adc     r14, rax
	adc     rbx, rdx
	mov     rax, [r13+r11*8+8]
	mul     rbp
	add     [rsi+r11*8+16], r14
	adc     rbx, rax
	adc     r10, rdx
	mov     rax, [r13+r11*8+16]
	mul     rbp
	xor     r9d, r9d
	xor     r14d, r14d
	add     [rsi+r11*8+24], rbx
	adc     r10, rax
	mov     rax, [r13+r11*8+24]
	adc     r9, rdx
	xor     ebx, ebx
	mul     rbp
	add     r11, 4
	js      L_lo1
L_ed1:	
    add     [rsi], r10
	adc     r9, rax
	adc     r14, rdx
	xor     r10d, r10d
	add     [rsi+8], r9
	adc     r14, 0
L_n1:	
    mov     [rsi+r12*8+16], r14
	add     rsi, 8
	dec     rcx
	jnz     L_o1
	lea     rsi, [rsi+16]
	jmp     L_common
	
L_b0:
	lea     rsi, [rsi-16]
L_o0:
	mov     r11, r12
	mov     rbp, [rsi+r12*8+16]
	imul    rbp, r8
	mov     rax, [r13+r11*8]
	xor     r10d, r10d
	mul     rbp
	mov     r14, rax
	mov     rbx, rdx
	jmp     L_mi0
	
	xalign  16
L_lo0:
	add     [rsi+r11*8], r10
	adc     r9, rax
	mov     rax, [r13+r11*8]
	adc     r14, rdx
	xor     r10d, r10d
	mul     rbp
	add     [rsi+r11*8+8], r9
	adc     r14, rax
	adc     rbx, rdx
L_mi0:
	mov     rax, [r13+r11*8+8]
	mul     rbp
	add     [rsi+r11*8+16], r14
	adc     rbx, rax
	adc     r10, rdx
	mov     rax, [r13+r11*8+16]
	mul     rbp
	xor     r9d, r9d
	xor     r14d, r14d
	add     [rsi+r11*8+24], rbx
	adc     r10, rax
	mov     rax, [r13+r11*8+24]
	adc     r9, rdx
	xor     ebx, ebx
	mul     rbp
	add     r11, 4
	js      L_lo0
L_ed0:
	add     [rsi], r10
	adc     r9, rax
	adc     r14, rdx
	xor     r10d, r10d
	add     [rsi+8], r9
	adc     r14, 0
	mov     [rsi+r12*8+16], r14
	add     rsi, 8
	dec     rcx
	jnz     L_o0
	lea     rsi, [rsi+16]
	jmp     L_common
L_b3:
	lea     r13, [r13-8]
	lea     rsi, [rsi-24]
L_o3:
	mov     r11, r12
	mov     rbp, [rsi+r12*8+24]
	imul    rbp, r8
	mov     rax, [r13+r11*8+8]
	mul     rbp
	mov     rbx, rax
	mov     r10, rdx
	jmp     L_mi3

	xalign  16
L_lo3:
	add     [rsi+r11*8], r10
	adc     r9, rax
	mov     rax, [r13+r11*8]
	adc     r14, rdx
	xor     r10d, r10d
	mul     rbp
	add     [rsi+r11*8+8], r9
	adc     r14, rax
	adc     rbx, rdx
	mov     rax, [r13+r11*8+8]
	mul     rbp
	add     [rsi+r11*8+16], r14
	adc     rbx, rax
	adc     r10, rdx
L_mi3:
	mov     rax, [r13+r11*8+16]
	mul     rbp
	xor     r9d, r9d
	xor     r14d, r14d
	add     [rsi+r11*8+24], rbx
	adc     r10, rax
	mov     rax, [r13+r11*8+24]
	adc     r9, rdx
	xor     ebx, ebx
	mul     rbp
	add     r11, 4
	js      L_lo3
L_ed3:
	add     [rsi+8], r10
	adc     r9, rax
	adc     r14, rdx
	xor     r10d, r10d
	add     [rsi+16], r9
	adc     r14, 0
	mov     [rsi+r12*8+24], r14
	add     rsi, 8
	dec     rcx
	jnz     L_o3
	lea     r13, [r13+8]
	lea     rsi, [rsi+24]
	jmp     L_common
L_b2:
	lea     r13, [r13-16]
	lea     rsi, [rsi-32]
L_o2:
	mov     r11, r12
	mov     rbp, [rsi+r12*8+32]
	imul    rbp, r8
	mov     rax, [r13+r11*8+16]
	mul     rbp
	xor     r14d, r14d
	mov     r10, rax
	mov     rax, [r13+r11*8+24]
	mov     r9, rdx
	jmp     L_mi2

	xalign  16
L_lo2:
	add     [rsi+r11*8], r10
	adc     r9, rax
	mov     rax, [r13+r11*8]
	adc     r14, rdx
	xor     r10d, r10d
	mul     rbp
	add     [rsi+r11*8+8], r9
	adc     r14, rax
	adc     rbx, rdx
	mov     rax, [r13+r11*8+8]
	mul     rbp
	add     [rsi+r11*8+16], r14
	adc     rbx, rax
	adc     r10, rdx
	mov     rax, [r13+r11*8+16]
	mul     rbp
	xor     r9d, r9d
	xor     r14d, r14d
	add     [rsi+r11*8+24], rbx
	adc     r10, rax
	mov     rax, [r13+r11*8+24]
	adc     r9, rdx
L_mi2:
	xor     ebx, ebx
	mul     rbp
	add     r11, 4
	js      L_lo2
L_ed2:
	add     [rsi+16], r10
	adc     r9, rax
	adc     r14, rdx
	xor     r10d, r10d
	add     [rsi+24], r9
	adc     r14, 0
	mov     [rsi+r12*8+32], r14
	add     rsi, 8
	dec     rcx
	jnz     L_o2
	lea     r13, [r13+16]
	lea     rsi, [rsi+32]
L_common:

	mov     rcx, rdi                    ; rp
    lea     rdx, [rsi+r12*8]            ; up
	lea     r8, [rdx+r12*8]             ; up - n
	mov     r9, [rsp+stack_use+0x20]    ; n
	call    __gmpn_add_n
	test    eax, eax
	jz      L_ret
	mov     rcx, rdi                    ; rp
	mov     rdx, rdi                    ; rp
    lea     r8, [r13+r12*8]             ; mp    
	mov     r9, [rsp+stack_use+0x20]    ; n
    call    __gmpn_sub_n
L_ret:
	WIN64_GCC_END

    end
