
;  AMD64 mpn_rsh1sub_n -- rp[] = (up[] - vp[]) >> 1
;  Copyright 2003, 2005 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	vp	rdx
%define 	n	rcx
%define 	n32	ecx

%define reg_save_list rbx, rsi, rdi

    BITS    64    
	SECTION .text

	xalign  16
	WIN64_GCC_PROC mpn_rsh1sub_n, 4
	movsxd  rcx, ecx
	
	xor     eax, eax
	mov     rbx, [rsi]
	sub     rbx, [rdx]
	rcr     rbx, 1
	adc     eax, eax
	mov     r11d, ecx
	and     r11d, 3
	cmp     r11d, 1
	je      L_do
L_n1:
	cmp     r11d, 2
    jne     L_n2
	add     rbx, rbx
	mov     r10, [rsi+8]
	sbb     r10, [rdx+8]
	lea     rsi, [rsi+8]
	lea     rdx, [rdx+8]
	lea     rdi, [rdi+8]
	rcr     r10, 1
	rcr     rbx, 1
	mov     [rdi-8], rbx
	jmp     L_cj1
L_n2:	
    cmp     r11d, 3
	jne     L_n3
	add     rbx, rbx
	mov     r9, [rsi+8]
	mov     r10, [rsi+16]
	sbb     r9, [rdx+8]
	sbb     r10, [rdx+16]
	lea     rsi, [rsi+16]
	lea     rdx, [rdx+16]
	lea     rdi, [rdi+16]
	rcr     r10, 1
	rcr     r9, 1
	rcr     rbx, 1
	mov     [rdi-16], rbx
	jmp     L_cj2
L_n3:	
    dec     rcx
	add     rbx, rbx
	mov     r8, [rsi+8]
	mov     r9, [rsi+16]
	sbb     r8, [rdx+8]
	sbb     r9, [rdx+16]
	mov     r10, [rsi+24]
	sbb     r10, [rdx+24]
	lea     rsi, [rsi+24]
	lea     rdx, [rdx+24]
	lea     rdi, [rdi+24]
	rcr     r10, 1
	rcr     r9, 1
	rcr     r8, 1
	rcr     rbx, 1
	mov     [rdi-24], rbx
	mov     [rdi-16], r8
L_cj2:	
    mov     [rdi-8], r9
L_cj1:	
    mov     rbx, r10
L_do:
	shr     rcx, 2
	je      L_end
	
	xalign  16
L_oop:
	add     rbx, rbx
	mov     r8, [rsi+8]
	mov     r9, [rsi+16]
	sbb     r8, [rdx+8]
	sbb     r9, [rdx+16]
	mov     r10, [rsi+24]
	mov     r11, [rsi+32]
	sbb     r10, [rdx+24]
	sbb     r11, [rdx+32]
	lea     rsi, [rsi+32]
	lea     rdx, [rdx+32]
	rcr     r11, 1
	rcr     r10, 1
	rcr     r9, 1
	rcr     r8, 1
	rcr     rbx, 1
	mov     [rdi], rbx
	mov     [rdi+8], r8
	mov     [rdi+16], r9
	mov     [rdi+24], r10
	mov     rbx, r11
	lea     rdi, [rdi+32]
	dec     rcx
	jne     L_oop
L_end:	
    mov     [rdi], rbx
	WIN64_GCC_END
	
	end
