
;  AMD64 mpn_rshift -- mpn left shift.
;  Copyright 2003, 2005 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;
;  This file is part of the GNU MP Library.
;
;  The GNU MP Library is free software; you can redistribute it and/or
;  modify it under the terms of the GNU Lesser General Public License as
;  published by the Free Software Foundation; either version 3 of the
;  License, or (at your option) any later version.
;
;  The GNU MP Library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;  Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define 	rp	rdi
%define 	up	rsi
%define 	n	rdx
%define 	cnt	ecx

%define reg_save_list rsi, rdi

    BITS    64    
	SECTION .text

	xalign  32
	WIN64_GCC_PROC mpn_rshift, 4
	movsxd  rdx, edx
	
	neg     ecx
	mov     rax, [rsi]
	shl     rax, cl
	neg     ecx
	lea     r8d, [rdx+1]
	lea     rsi, [rsi+rdx*8-8]
	lea     rdi, [rdi+rdx*8-8]
	neg     rdx
	and     r8d, 3
	je      L_rlx
	dec     r8d
	jne     L_1
	mov     r10, [rsi+rdx*8+8]
	shr     r10, cl
	neg     ecx
	mov     r8, [rsi+rdx*8+16]
	shl     r8, cl
	or      r10, r8
	mov     [rdi+rdx*8+8], r10
	inc     rdx
	jmp     L_rll
L_1:	
    dec     r8d
    je      L_1x
	mov     r10, [rsi+rdx*8+8]
	shr     r10, cl
	neg     ecx
	mov     r8, [rsi+rdx*8+16]
	shl     r8, cl
	or      r10, r8
	mov     [rdi+rdx*8+8], r10
	inc     rdx
	neg     ecx
L_1x:
	cmp     rdx, -1
	je      L_ast
	mov     r10, [rsi+rdx*8+8]
	shr     r10, cl
	mov     r11, [rsi+rdx*8+16]
	shr     r11, cl
	neg     ecx
	mov     r8, [rsi+rdx*8+16]
	mov     r9, [rsi+rdx*8+24]
	shl     r8, cl
	or      r10, r8
	shl     r9, cl
	or      r11, r9
	mov     [rdi+rdx*8+8], r10
	mov     [rdi+rdx*8+16], r11
	add     rdx, 2
L_rll:	
    neg     ecx
L_rlx:	
    mov     r10, [rsi+rdx*8+8]
	shr     r10, cl
	mov     r11, [rsi+rdx*8+16]
	shr     r11, cl
	add     rdx, 4
	jb      L_end
	
	xalign  16
L_oop:
	neg     ecx
	mov     r8, [rsi+rdx*8-16]
	mov     r9, [rsi+rdx*8-8]
	shl     r8, cl
	or      r10, r8
	shl     r9, cl
	or      r11, r9
	mov     [rdi+rdx*8-24], r10
	mov     [rdi+rdx*8-16], r11

	mov     r8, [rsi+rdx*8]
	mov     r9, [rsi+rdx*8+8]
	shl     r8, cl
	shl     r9, cl

	neg     ecx
	mov     r10, [rsi+rdx*8-8]
	mov     r11, [rsi+rdx*8+0]
	shr     r10, cl
	or      r8, r10
	shr     r11, cl
	or      r9, r11
	mov     [rdi+rdx*8-8], r8
	mov     [rdi+rdx*8+0], r9

	mov     r10, [rsi+rdx*8+8]
	mov     r11, [rsi+rdx*8+16]
	shr     r10, cl
	shr     r11, cl
	add     rdx, 4
	jae     L_oop
L_end:
	neg     ecx
	mov     r8, [rsi+rdx*8-16]
	shl     r8, cl
	or      r10, r8
	mov     r9, [rsi+rdx*8-8]
	shl     r9, cl
	or      r11, r9
	mov     [rdi+rdx*8-24], r10
	mov     [rdi+rdx*8-16], r11
	neg     ecx
L_ast:	
    mov     r10, [rsi]
	shr     r10, cl
	mov     [rdi], r10
	WIN64_GCC_END
	
	end
