
;  AMD64 mpn_sqr_basecase.
;  Contributed to the GNU project by Torbjorn Granlund.
;  Copyright 2008 Free Software Foundation, Inc.
;  Windows (x64) conversion: Copyright 2009 Brian Gladman, Worcester, UK.
;  This file is part of the GNU MP Library.
;  The GNU MP Library is free software; you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published
;  by the Free Software Foundation; either version 3 of the License, or (at
;  your option) any later version.
;  The GNU MP Library is distributed in the hope that it will be useful, but
;  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
;  License for more details.
;  You should have received a copy of the GNU Lesser General Public License
;  along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

%include "yasm_mac.inc"

%define SQR_KARATSUBA_THRESHOLD_MAX 120
%define STACK_ALLOC (8 * 2 * SQR_KARATSUBA_THRESHOLD_MAX)
%define SPECIAL_CODE_FOR_4 1

%define     rp  rdi
%define     up  rsi
%define     n_param rdx
%define     n   r11
%define     tp  r12
%define     i   r8
%define     j   r9
%define     v0  r13
%define     v1  r14
%define     w0  rbx
%define     w1  rcx
%define     w2  rbp
%define     w3  r10

%define reg_save_list rbx, rbp, rsi, rdi, r12, r13, r14, r15

    BITS    64
    SECTION .text

    global  __gmpn_sqr_basecase

%ifdef DLL
    export  __gmpn_sqr_basecase
%endif

    xalign  16
    PROC_FRAME __gmpn_sqr_basecase
    push_reg    rbx
    push_reg    rbp
    push_reg    rsi
    push_reg    rdi
    push_reg    r12
    push_reg    r13
    push_reg    r14
    push_reg    r15
    alloc_stack   8
    set_frame   r15, 0
    END_PROLOGUE

    mov     rdi, rcx
    mov     rsi, rdx
    movsxd  rdx, r8d

    mov     r11d, edx
    mov     ecx, edx
    and     ecx, 3
    lea     rbx, [rcx+4]
    cmp     r11d, 4
    cmovg   rcx, rbx

%if 1

    lea     rdx, [rel L_jmptab]
    mov     ecx, [rdx+rcx*4]
    lea     rax, [rip+0]
L_99:
    add     rcx, rax
    jmp     rcx

    SECTION .data
    xalign  8
L_jmptab:
    dd     L_4 - L_99
    dd     L_1 - L_99
    dd     L_2 - L_99
    dd     L_3 - L_99
    dd     L_0m4 - L_99
    dd     L_1m4 - L_99
    dd     L_2m4 - L_99
    dd     L_3m4 - L_99
    SECTION .text

%else

    lea     rdx, [rel L_jmptab]
    mov     ecx, [rdx+rcx*4]
    add     rcx, rdx
    jmp     rcx

    SECTION .data
    xalign  8
L_jmptab:
    dd     L_4 - L_jmptab
    dd     L_1 - L_jmptab
    dd     L_2 - L_jmptab
    dd     L_3 - L_jmptab
    dd     L_0m4 - L_jmptab
    dd     L_1m4 - L_jmptab
    dd     L_2m4 - L_jmptab
    dd     L_3m4 - L_jmptab
    SECTION .text

%endif

L_1:
    mov     rax, [rsi]
    mul     rax
    mov     [rdi], rax
    mov     [rdi+8], rdx
    jmp     L_xit

L_2:
    mov     rax, [rsi]
    mul     rax
    mov     [rdi], rax
    mov     r9, rdx
    mov     rax, [rsi+8]
    mul     rax
    mov     r10, rax
    mov     r11, rdx
    mov     rax, [rsi+8]
    mov     rbx, [rsi]
    mul     rbx
    add     r9, rax
    adc     r10, rdx
    adc     r11, 0
    add     r9, rax
    mov     [rdi+8], r9
    adc     r10, rdx
    mov     [rdi+16], r10
    adc     r11, 0
    mov     [rdi+24], r11
    jmp     L_xit

L_3:
    mov     rax, [rsi]
    mul     rax
    mov     [rdi], rax
    mov     [rdi+8], rdx
    mov     rax, [rsi+8]
    mul     rax
    mov     [rdi+16], rax
    mov     [rdi+24], rdx
    mov     rax, [rsi+16]
    mul     rax
    mov     [rdi+32], rax
    mov     [rdi+40], rdx
    mov     rbx, [rsi]
    mov     rax, [rsi+8]
    mul     rbx
    mov     r8, rax
    mov     r9, rdx
    mov     rax, [rsi+16]
    mul     rbx
    xor     r10d, r10d
    add     r9, rax
    adc     r10, rdx
    mov     rbx, [rsi+8]
    mov     rax, [rsi+16]
    mul     rbx
    xor     r11d, r11d
    add     r10, rax
    adc     r11, rdx
    add     r8, r8
    adc     r9, r9
    adc     r10, r10
    adc     r11, r11
    mov     ebx, 0
    adc     rbx, rbx
    add     [rdi+8], r8
    adc     [rdi+16], r9
    adc     [rdi+24], r10
    adc     [rdi+32], r11
    adc     [rdi+40], rbx
    jmp     L_xit

%ifdef SPECIAL_CODE_FOR_4

L_4:
    mov     rax, [rsi]
    mul     rax
    mov     [rdi], rax
    mov     [rdi+8], rdx
    mov     rax, [rsi+8]
    mul     rax
    mov     [rdi+16], rax
    mov     [rdi+24], rdx
    mov     rax, [rsi+16]
    mul     rax
    mov     [rdi+32], rax
    mov     [rdi+40], rdx
    mov     rax, [rsi+24]
    mul     rax
    mov     [rdi+48], rax
    mov     [rdi+56], rdx

    mov     rbx, [rsi]
    mov     rax, [rsi+8]
    mul     rbx
    mov     r8, rax
    mov     r9, rdx
    mov     rax, [rsi+16]
    mul     rbx
    xor     r10d, r10d
    add     r9, rax
    adc     r10, rdx
    mov     rax, [rsi+24]
    mul     rbx
    xor     r11d, r11d
    add     r10, rax
    adc     r11, rdx
    mov     rbx, [rsi+8]
    mov     rax, [rsi+16]
    mul     rbx
    xor     r12d, r12d
    add     r10, rax
    adc     r11, rdx
    adc     r12, 0
    mov     rax, [rsi+24]
    mul     rbx
    add     r11, rax
    adc     r12, rdx
    mov     rbx, [rsi+16]
    mov     rax, [rsi+24]
    mul     rbx
    xor     ebp, ebp
    add     r12, rax
    adc     rbp, rdx

    add     r8, r8
    adc     r9, r9
    adc     r10, r10
    adc     r11, r11
    adc     r12, r12
    mov     ebx, 0
    adc     rbp, rbp
    adc     rbx, rbx

    add     [rdi+8], r8
    adc     [rdi+16], r9
    adc     [rdi+24], r10
    adc     [rdi+32], r11
    adc     [rdi+40], r12
    adc     [rdi+48], rbp
    adc     [rdi+56], rbx
    jmp     L_xit

%endif

L_0m4:
    add     rsp, -STACK_ALLOC
    lea     r12, [rsp+r11*8]
    lea     rsi, [rsi+r11*8]
    lea     r8, [r11-1]
    mov     r9, -1
    sub     r9, r8
    lea     r12, [r12-24]
    mov     r13, [rsi+r9*8]
    mov     rax, [rsi+r9*8+8]
    mul     r13
    xor     ebp, ebp
    mov     rbx, rax
    mov     rax, [rsi+r9*8+16]
    mov     r10, rdx
    jmp     L_L3

    xalign  16
L_mul_1_m3_top:
    add     rbp, rax
    mov     [r12+r9*8], r10
    mov     rax, [rsi+r9*8]
    adc     rcx, rdx
    xor     ebx, ebx
    mul     r13
    xor     r10d, r10d
    mov     [r12+r9*8+8], rbp
    add     rcx, rax
    adc     rbx, rdx
    mov     rax, [rsi+r9*8+8]
    mov     [r12+r9*8+16], rcx
    xor     ebp, ebp
    mul     r13
    add     rbx, rax
    mov     rax, [rsi+r9*8+16]
    adc     r10, rdx
L_L3:
    xor     ecx, ecx
    mul     r13
    add     r10, rax
    mov     rax, [rsi+r9*8+24]
    adc     rbp, rdx
    mov     [r12+r9*8+24], rbx
    mul     r13
    add     r9, 4
    js      L_mul_1_m3_top
    add     rbp, rax
    mov     [r12], r10
    adc     rcx, rdx
    mov     [r12+8], rbp
    mov     [r12+16], rcx
    lea     r12, [r12+2*8+24]

%ifdef  SPECIAL_CODE_FOR_4
    cmp     r8d, 3
    je      L_last
%endif
    jmp     L_dowhile

L_1m4:
    add     rsp, -STACK_ALLOC
    lea     r12, [rsp+r11*8]
    lea     rsi, [rsi+r11*8]
    lea     r8, [r11]
    mov     r9d, 3
    sub     r9, r8
    lea     rsi, [rsi+8]
    mov     r13, [rsi+r9*8-32]
    mov     r14, [rsi+r9*8-24]
    mov     rax, [rsi+r9*8-24]
    mul     r13
    mov     rcx, rdx
    xor     ebp, ebp
    mov     [r12+r9*8-24], rax
    jmp     L_m0

    xalign  16
L_mul_2_m0_top:
    mul     r14
    add     rbx, rax
    adc     rcx, rdx
    mov     rax, [rsi+r9*8-24]
    mov     ebp, 0
    mul     r13
    add     rbx, rax
    mov     rax, [rsi+r9*8-24]
    adc     rcx, rdx
    adc     ebp, 0
    mul     r14
    add     rcx, rax
    mov     [r12+r9*8-24], rbx
    adc     rbp, rdx
L_m0:
    mov     rax, [rsi+r9*8-16]
    mul     r13
    mov     r10d, 0
    add     rcx, rax
    adc     rbp, rdx
    mov     rax, [rsi+r9*8-16]
    adc     r10d, 0
    mov     ebx, 0
    mov     [r12+r9*8-16], rcx
    mul     r14
    add     rbp, rax
    mov     rax, [rsi+r9*8-8]
    adc     r10, rdx
    mov     ecx, 0
    mul     r13
    add     rbp, rax
    mov     rax, [rsi+r9*8-8]
    adc     r10, rdx
    adc     ebx, 0
    mul     r14
    add     r10, rax
    mov     [r12+r9*8-8], rbp
    adc     rbx, rdx
    mov     rax, [rsi+r9*8]
    mul     r13
    add     r10, rax
    adc     rbx, rdx
    adc     ecx, 0
    add     r9, 4
    mov     rax, [rsi+r9*8-32]
    mov     [r12+r9*8-32], r10
    js      L_mul_2_m0_top
    mul     r14
    add     rbx, rax
    adc     rcx, rdx
    mov     [r12-8], rbx
    mov     [r12], rcx
    lea     rsi, [rsi-8]
    lea     r12, [r12+3*8]
    add     r8d, -2
    cmp     r8d, 3
    je      L_last
    jmp     L_dowhile

L_2m4:
    add     rsp, -STACK_ALLOC
    lea     r12, [rsp+r11*8]
    lea     rsi, [rsi+r11*8]
    lea     r8, [r11-1]
    mov     r9d, 1
    sub     r9, r8
    lea     r12, [r12-24]
    mov     r13, [rsi+r9*8-16]
    mov     rax, [rsi+r9*8-8]
    mul     r13
    mov     rbp, rax
    mov     rax, [rsi+r9*8]
    mov     rcx, rdx
    jmp     L_L1

    xalign  16
L_mul_1_m1_top:
    add     rbp, rax
    mov     [r12+r9*8], r10
    mov     rax, [rsi+r9*8]
    adc     rcx, rdx
L_L1:
    xor     ebx, ebx
    mul     r13
    xor     r10d, r10d
    mov     [r12+r9*8+8], rbp
    add     rcx, rax
    adc     rbx, rdx
    mov     rax, [rsi+r9*8+8]
    mov     [r12+r9*8+16], rcx
    xor     ebp, ebp
    mul     r13
    add     rbx, rax
    mov     rax, [rsi+r9*8+16]
    adc     r10, rdx
    xor     ecx, ecx
    mul     r13
    add     r10, rax
    mov     rax, [rsi+r9*8+24]
    adc     rbp, rdx
    mov     [r12+r9*8+24], rbx
    mul     r13
    add     r9, 4
    js      L_mul_1_m1_top
    add     rbp, rax
    mov     [r12], r10
    adc     rcx, rdx
    mov     [r12+8], rbp
    mov     [r12+16], rcx
    lea     r12, [r12+2*8+24]
    jmp     L_dowhile_mid

L_3m4:
    add     rsp, -STACK_ALLOC
    lea     r12, [rsp+r11*8]
    lea     rsi, [rsi+r11*8]
    lea     r8, [r11]
    mov     r9d, 1
    sub     r9, r8
    lea     rsi, [rsi+8]
    mov     r13, [rsi+r9*8-16]
    mov     r14, [rsi+r9*8-8]
    mov     rax, [rsi+r9*8-8]
    mul     r13
    mov     r10, rdx
    xor     ebx, ebx
    xor     ecx, ecx
    mov     [r12+r9*8-8], rax
    jmp     L_m2

    xalign  16
L_mul_2_m2_top:
    mul     r14
    add     rbx, rax
    adc     rcx, rdx
    mov     rax, [rsi+r9*8-24]
    mov     ebp, 0
    mul     r13
    add     rbx, rax
    mov     rax, [rsi+r9*8-24]
    adc     rcx, rdx
    adc     ebp, 0
    mul     r14
    add     rcx, rax
    mov     [r12+r9*8-24], rbx
    adc     rbp, rdx
    mov     rax, [rsi+r9*8-16]
    mul     r13
    mov     r10d, 0
    add     rcx, rax
    adc     rbp, rdx
    mov     rax, [rsi+r9*8-16]
    adc     r10d, 0
    mov     ebx, 0
    mov     [r12+r9*8-16], rcx
    mul     r14
    add     rbp, rax
    mov     rax, [rsi+r9*8-8]
    adc     r10, rdx
    mov     ecx, 0
    mul     r13
    add     rbp, rax
    mov     rax, [rsi+r9*8-8]
    adc     r10, rdx
    adc     ebx, 0
    mul     r14
    add     r10, rax
    mov     [r12+r9*8-8], rbp
    adc     rbx, rdx
L_m2:
    mov     rax, [rsi+r9*8]
    mul     r13
    add     r10, rax
    adc     rbx, rdx
    adc     ecx, 0
    add     r9, 4
    mov     rax, [rsi+r9*8-32]
    mov     [r12+r9*8-32], r10
    js      L_mul_2_m2_top
    mul     r14
    add     rbx, rax
    adc     rcx, rdx
    mov     [r12-8], rbx
    mov     [r12], rcx
    lea     rsi, [rsi-8]
    lea     r12, [r12+3*8]
    add     r8d, -2
    jmp     L_dowhile_mid

L_dowhile:
    mov     r9, -1
    sub     r9, r8
    lea     r12, [r12-24]
    lea     rsi, [rsi-8]
    mov     r13, [rsi+r9*8+16]
    mov     r14, [rsi+r9*8+24]
    mov     rax, [rsi+r9*8+24]
    mul     r13
    xor     r10d, r10d
    add     [r12+r9*8+24], rax
    adc     r10, rdx
    xor     ebx, ebx
    xor     ecx, ecx
    jmp     L_am2

    xalign  16
L_addmul_2_m2_top:
    add     [r12+r9*8], r10
    adc     rbx, rax
    mov     rax, [rsi+r9*8+8]
    adc     rcx, rdx
    mov     ebp, 0
    mul     r13
    add     rbx, rax
    mov     rax, [rsi+r9*8+8]
    adc     rcx, rdx
    adc     ebp, 0
    mul     r14
    add     [r12+r9*8+8], rbx
    adc     rcx, rax
    adc     rbp, rdx
    mov     rax, [rsi+r9*8+16]
    mov     r10d, 0
    mul     r13
    add     rcx, rax
    mov     rax, [rsi+r9*8+16]
    adc     rbp, rdx
    adc     r10d, 0
    mul     r14
    add     [r12+r9*8+16], rcx
    adc     rbp, rax
    mov     rax, [rsi+r9*8+24]
    adc     r10, rdx
    mul     r13
    mov     ebx, 0
    add     rbp, rax
    adc     r10, rdx
    mov     ecx, 0
    mov     rax, [rsi+r9*8+24]
    adc     ebx, 0
    mul     r14
    add     [r12+r9*8+24], rbp
    adc     r10, rax
    adc     rbx, rdx
L_am2:
    mov     rax, [rsi+r9*8+32]
    mul     r13
    add     r10, rax
    mov     rax, [rsi+r9*8+32]
    adc     rbx, rdx
    adc     ecx, 0
    mul     r14
    add     r9, 4
    js      L_addmul_2_m2_top
    add     [r12], r10
    adc     rbx, rax
    adc     rcx, rdx
    mov     [r12+8], rbx
    mov     [r12+16], rcx
    lea     r12, [r12+2*8]
    add     r8d, -2
    lea     r12, [r12+24]
    lea     rsi, [rsi+8]

L_dowhile_mid:
    mov     r9d, 1
    sub     r9, r8
    lea     r12, [r12-24]
    lea     rsi, [rsi-8]
    mov     r13, [rsi+r9*8]
    mov     r14, [rsi+r9*8+8]
    mov     rax, [rsi+r9*8+8]
    mul     r13
    xor     ecx, ecx
    add     [r12+r9*8+8], rax
    adc     rcx, rdx
    xor     ebp, ebp
    jmp     L_20

    xalign  16
L_addmul_2_m0_top:
    add     [r12+r9*8], r10
    adc     rbx, rax
    mov     rax, [rsi+r9*8+8]
    adc     rcx, rdx
    mov     ebp, 0
    mul     r13
    add     rbx, rax
    mov     rax, [rsi+r9*8+8]
    adc     rcx, rdx
    adc     ebp, 0
    mul     r14
    add     [r12+r9*8+8], rbx
    adc     rcx, rax
    adc     rbp, rdx
L_20:
    mov     rax, [rsi+r9*8+16]
    mov     r10d, 0
    mul     r13
    add     rcx, rax
    mov     rax, [rsi+r9*8+16]
    adc     rbp, rdx
    adc     r10d, 0
    mul     r14
    add     [r12+r9*8+16], rcx
    adc     rbp, rax
    mov     rax, [rsi+r9*8+24]
    adc     r10, rdx
    mul     r13
    mov     ebx, 0
    add     rbp, rax
    adc     r10, rdx
    mov     ecx, 0
    mov     rax, [rsi+r9*8+24]
    adc     ebx, 0
    mul     r14
    add     [r12+r9*8+24], rbp
    adc     r10, rax
    adc     rbx, rdx
    mov     rax, [rsi+r9*8+32]
    mul     r13
    add     r10, rax
    mov     rax, [rsi+r9*8+32]
    adc     rbx, rdx
    adc     ecx, 0
    mul     r14
    add     r9, 4
    js      L_addmul_2_m0_top

    add     [r12], r10
    adc     rbx, rax
    adc     rcx, rdx
    mov     [r12+8], rbx
    mov     [r12+16], rcx
    lea     r12, [r12+24]
    lea     rsi, [rsi+8]
    lea     r12, [r12+2*8]
    add     r8d, -2
    cmp     r8d, 3
    jne     L_dowhile
L_last:
    mov     r13, [rsi-24]
    mov     r14, [rsi-16]
    mov     rax, [rsi-16]
    mul     r13
    xor     r10d, r10d
    add     [r12-32], rax
    adc     r10, rdx
    xor     ebx, ebx
    xor     ecx, ecx
    mov     rax, [rsi-8]
    mul     r13
    add     r10, rax
    mov     rax, [rsi-8]
    adc     rbx, rdx
    mul     r14
    add     [r12-24], r10
    adc     rbx, rax
    adc     rcx, rdx
    mov     [r12-16], rbx
    mov     [r12-8], rcx
    mov     r9d, r11d
    shl     r11, 3
    sub     rsi, r11
    mov     r11, [rsp]
    bt      r9, 0
    lea     r9, [r9+r9-4]
    jc      L_odd
L_evn:
    lea     rdi, [rdi+r9*8]
    lea     rsi, [rsi+r9*4]
    lea     r12, [rsp+r9*8+8]
    neg     r9
    add     r11, r11
    sbb     ebx, ebx
    mov     rax, [rsi+r9*4]
    mul     rax
    add     r11, rdx
    mov     [rdi+r9*8], rax
    jmp     L_d0
L_odd:
    lea     rdi, [rdi+r9*8-16]
    lea     rsi, [rsi+r9*4-8]
    lea     r12, [rsp+r9*8-8]
    neg     r9
    add     r11, r11
    sbb     ebp, ebp
    mov     rax, [rsi+r9*4+8]
    mul     rax
    add     r11, rdx
    mov     [rdi+r9*8+16], rax
    jmp     L_d1

    xalign  16
L_top:
    mov     rax, [rsi+r9*4]
    mul     rax
    add     ebp, ebp
    adc     r10, rax
    adc     r11, rdx
    mov     [rdi+r9*8], r10
L_d0:
    mov     [rdi+r9*8+8], r11
    mov     r10, [r12+r9*8]
    adc     r10, r10
    mov     r11, [r12+r9*8+8]
    adc     r11, r11
    nop
    sbb     ebp, ebp
    mov     rax, [rsi+r9*4+8]
    mul     rax
    add     ebx, ebx
    adc     r10, rax
    adc     r11, rdx
    mov     [rdi+r9*8+16], r10
L_d1:
    mov     [rdi+r9*8+24], r11
    mov     r10, [r12+r9*8+16]
    adc     r10, r10
    mov     r11, [r12+r9*8+24]
    adc     r11, r11
    sbb     ebx, ebx
    add     r9, 4
    js      L_top
L_end:
    mov     rax, [rsi+r9*4]
    mul     rax
    add     ebp, ebp
    adc     r10, rax
    adc     r11, rdx
    mov     [rdi+r9*8], r10
    mov     [rdi+r9*8+8], r11
    mov     r10, [r12+r9*8]
    adc     r10, r10
    sbb     ebp, ebp
    neg     ebp
    mov     rax, [rsi+r9*4+8]
    mul     rax
    add     ebx, ebx
    adc     r10, rax
    adc     rdx, rbp
    mov     [rdi+r9*8+16], r10
    mov     [rdi+r9*8+24], rdx
L_xit:
    mov     rsp, r15
    add     rsp, 8
    pop     r15
    pop     r14
    pop     r13
    pop     r12
    pop     rdi
    pop     rsi
    pop     rbp
    pop     rbx
    ret
    ENDPROC_FRAME

    end
